<?php

// uncomment the following to define a path alias
// Yii::setPathOfAlias('local','path/to/local-folder');

// This is the main Web application configuration. Any writable
// CWebApplication properties can be configured here.

Yii::setPathOfAlias('bootstrap', dirname(__FILE__).'/../extensions/bootstrap');

return array(
	'basePath'=>dirname(__FILE__).DIRECTORY_SEPARATOR.'..',
        'theme'=>'bootstrap', // requires you to copy the theme under your themes directory
	'name'=>'Radiorama Ingeniería',
        'language' => 'es', 
	'defaultController'=>'estaciones/admin',
	// preloading 'log' component
        
	'preload'=>array('log'),
        
	// autoloading model and component classes
	'import'=>array(
		'application.models.*',
		'application.components.*',
                'ext.AweCrud.components.*', // AweCrud components
	),
        
    
        'aliases' => array(    
            //If you manually installed it
            'xupload' => 'ext.xupload',
        ),
    
	'modules'=>array(
		// uncomment the following to enable the Gii tool
		
		/*'gii'=>array(
			'class'=>'system.gii.GiiModule',
			'password'=>'admin',
			// If removed, Gii defaults to localhost only. Edit carefully to taste.
			'ipFilters'=>array('127.0.0.1','::1'),
		),*/
                'gii' => array(
                    'class' => 'system.gii.GiiModule',
                    'password'=>'admin',
                    'generatorPaths' => array(
                        'ext.AweCrud.generators', // AweCrud generators
                        'bootstrap.gii',
                ),
                    //'generatorPaths' =>array('ext.mpgii'),//this line does the trick
        ),
		
	),

	// application components
	'components'=>array(
		'user'=>array(
			// enable cookie-based authentication
			'allowAutoLogin'=>true,
		),
		// uncomment the following to enable URLs in path-format
		/*
		'urlManager'=>array(
			'urlFormat'=>'path',
			'rules'=>array(
				'<controller:\w+>/<id:\d+>'=>'<controller>/view',
				'<controller:\w+>/<action:\w+>/<id:\d+>'=>'<controller>/<action>',
				'<controller:\w+>/<action:\w+>'=>'<controller>/<action>',
			),
		),
		
		'db'=>array(
			'connectionString' => 'sqlite:'.dirname(__FILE__).'/../data/testdrive.db',
		),
                 * 
                 */
            
                 //...Pdf
                 'ePdf' => array(
                    'class'         => 'ext.yii-pdf.EYiiPdf',
                    'params'        => array(
                        'HTML2PDF' => array(
                            'librarySourcePath' => 'application.vendors.html2pdf.*',
                            'classFile'         => 'html2pdf.class.php', // For adding to Yii::$classMap
                            'defaultParams'     => array( // More info: http://wiki.spipu.net/doku.php?id=html2pdf:en:v4:accueil
                                'orientation' => 'P', // landscape or portrait orientation
                                'format'      => 'A4', // format A4, A5, ...
                                'language'    => 'en', // language: fr, en, it ...
                                'unicode'     => true, // TRUE means clustering the input text IS unicode (default = true)
                                'encoding'    => 'UTF-8', // charset encoding; Default is UTF-8
                                'marges'      => array(5, 10, 5, 10), // margins by default, in order (left, top, right, bottom)
                            )
                        )
                    ),
                ),
                //...Pdf
                 
            
		// uncomment the following to use a MySQL database
                
                'db'=>array(
			'connectionString' => 'mysql:host=localhost;dbname=radiorama_ingenieria',
			'emulatePrepare' => true,
			'username' => 'root',
			'password' => 'root',
			'charset' => 'utf8',
                        'enableParamLogging' => true,
                        'enableProfiling'=>true,
		),
                'db'=>array(
			'connectionString' => 'mysql:host=localhost;dbname=aplradio_ingev1_prod',
			'emulatePrepare' => true,
			'username' => 'aplradio_inge',
			'password' => 'Jur1d1c0$',
			'charset' => 'utf8',
		),
                'joomla'=>array(
                    'class'=>'CDbConnection',//!important
                    'emulatePrepare' => true,
                    'connectionString'=>'mysql:host=localhost;dbname=radiorama_ingenieria2',
                    'username'=>'root',
                    'password'=>'root',
                    'charset' => 'utf8',
                ),
		'errorHandler'=>array(
			// use 'site/error' action to display errors
			'errorAction'=>'site/error',
		),
                /*
		'log'=>array(
			'class'=>'CLogRouter',
			'routes'=>array(
				array(
					'class'=>'ext.yii-debug-toolbar.YiiDebugToolbarRoute',
                                        'ipFilters'=>array('127.0.0.1','192.168.1.215'),
					//'levels'=>'error, warning',
				),
				// uncomment the following to show log messages on web pages
				
				array(
					'class'=>'CWebLogRoute',
				),
				
			),
		),
                 * 
                 */
                'messages' => array(
                        // 'class' => 'MessageSource',
                        'extensionPaths' => array(
                        'AweCrud' => 'ext.AweCrud.messages', // AweCrud messages directory.
                        ),
                ),
                'bootstrap'=>array(
                    'class'=>'bootstrap.components.Bootstrap',
                    'responsiveCss' => true,
                    'fontAwesomeCss' => true,
                ),
                /*
                'urlManager'=>array(
                    'urlFormat'=>'path',
                    'showScriptName'=>true,
                    'rules'=>array(
                            '<controller:\w+>/<id:\d+>'=>'<controller>/view',
                            '<controller:\w+>/<action:\w+>/<id:\d+>'=>'<controller>/<action>',
                            '<controller:\w+>/<action:\w+>'=>'<controller>/<action>',
                    ),
                ),
                 * 
                 */
	),

	// application-level parameters that can be accessed
	// using Yii::app()->params['paramName']
	'params'=>array(
		// this is used in contact page
		'adminEmail'=>'webmaster@example.com',
		'imagenes' => "/archivos/uploads/",
	),
);
