<?php

class EstacionesController extends AweController
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
        public $layout = '//layouts/column2b';

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
                $this->layout = '//layouts/column1';
		$this->render('view', array(
			'model' => $this->loadModel($id),
		));
	}
        
	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
                
		$model = new Estaciones;
		Yii::import ( "xupload.models.XUploadForm" );
		$archivoForm = new XUploadForm ();
		//$archivoForm->uploadView = "uploadEstaciones";
		
                $this->performAjaxValidation($model, 'estaciones-form');

		if(isset($_POST['Estaciones']))
		{
			$model->attributes = $_POST['Estaciones'];
			$transaction = Yii::app ()->db->beginTransaction ();
			try {
				// Save the model to the database
				if ($model->save ()) {
					$transaction->commit ();
					$this->redirect ( array (
							'estaciones/view',
							'id' => $model->idEstacion
					) );
				}
			} catch ( Exception $e ) {
				$transaction->rollback ();
				Yii::app ()->handleException ( $e );
			}
			
		}

		$this->render('create',array(
			'model' => $model,
			'archivoForm' => $archivoForm,
		));
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		Yii::app()->clientScript->registerCoreScript('jquery.ui', CClientScript::POS_HEAD);
                $model = $this->loadModel($id);
                
		Yii::import ( "xupload.models.XUploadForm" );
		$archivoForm = new XUploadForm ();
		//$archivoForm->uploadView = "uploadEstaciones";
		
        $this->performAjaxValidation($model, 'estaciones-form');

		if(isset($_POST['Estaciones']))
		{
			$model->attributes = $_POST['Estaciones'];

			$transaction = Yii::app ()->db->beginTransaction ();
			try {
				// Save the model to the database
				if ($model->save ()) {
					$transaction->commit ();
					$this->redirect ( array (
							'estaciones/view',
							'id' => $model->idEstacion
					) );
				}
			} catch ( Exception $e ) {
				$transaction->rollback ();
				Yii::app ()->handleException ( $e );
			}
			
		}

		$this->render('update',array(
			'model' => $model,
			'archivoForm' => $archivoForm,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		if(Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			try
                        {
                           // Try to delete
                           $this->loadModel($id)->delete();
                           
                        }
                        catch (CDbException $e)
                        {
                          // Do something else (eg update record)
                          if($e->errorInfo[1]){
                              echo "Imposible eliminar esta estacion, primero elimine toda la información relacionada en las pestañas inferiores";
                              
                          }else{
                              echo "Ocurrio un error al procesar tu solicitud";
                          }
                        }

			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
				$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
		}
		else
			throw new CHttpException(400, 'Invalid request. Please do not repeat this request again.');
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$dataProvider=new CActiveDataProvider('Estaciones');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}
        
        
        /**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
            $this->layout = '//layouts/column1';
		$model = new Estaciones('search');
		$model->unsetAttributes(); // clear any default values
		if(isset($_GET['Estaciones']))
			$model->attributes = $_GET['Estaciones'];

		$this->render('admin', array(
			'model' => $model,
		));
	}
        
        /**
	 * Generador de Reportes
	 */
	public function actionReportes()
	{
            $this->layout = '//layouts/column1';
		$model = new Estaciones('search');
		$model->unsetAttributes(); // clear any default values
		if(isset($_GET['Estaciones']))
			$model->attributes = $_GET['Estaciones'];

		$this->render('reportes', array(
			'model' => $model,
		));
	}
        
        /*
         * Reporte Transmisores FM
         */
        public function actionRTransmisoresFM(){
            $this->layout = '//layouts/column1';
            $model = new TransmisoresFM('search');
            $model->unsetAttributes(); // clear any default values
            if (isset($_GET['TransmisoresFM']))
                $model->attributes = $_GET['TransmisoresFM'];

            $this->render('rtransmisoresfm', array(
                'model' => $model,
            ));
        }
        
        /*
         * Reporte Transmisores AM
         */
        public function actionRTransmisoresAM(){
            $this->layout = '//layouts/column1';
            $model = new TransmisoresAM('search');
            $model->unsetAttributes(); // clear any default values
            if (isset($_GET['TransmisoresAM']))
                $model->attributes = $_GET['TransmisoresAM'];

            $this->render('rtransmisoresam', array(
                'model' => $model,
            ));
        }
        
        /**
	 * Reporte de Observaciones
	 */
	public function actionRObservaciones()
	{
            $this->layout = '//layouts/column1';
		$model = new Observaciones('search');
		$model->unsetAttributes(); // clear any default values
		if(isset($_GET['Observaciones']))
			$model->attributes = $_GET['Observaciones'];

		$this->render('robservaciones', array(
			'model' => $model,
		));
	}
        
        /**
        * Reportes Ifetel
        */
       public function actionRIfetel() {
           $this->layout = '//layouts/column1';
           $model = new Cofetel('search');
           $model->unsetAttributes(); // clear any default values
           if (isset($_GET['Cofetel']))
               $model->attributes = $_GET['Cofetel'];

           $this->render('rifetel', array(
               'model' => $model,
           ));
       }
        
        public function actionBorrararchivos(){
            if( isset( $_GET["_method"] ) ) {
                if( $_GET["_method"] == "delete" ) {
                    $success = is_file( $_GET["file"] ) && $_GET["file"][0] !== '.' && unlink( $_GET["file"] );
                    if($success){
                        $res = Archivos::model()->deleteByPk(intval($_GET['id']));
                        if($res>0){
                            //echo "Archivo Borrado";
                        }else{
                            echo "Ocurio un error al borrar el archivo, intente nuevamente";
                        }
                    }else{
                        echo "Archivo no existe, intente nuevamente";
                    }
                }
            }
        }

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the ID of the model to be loaded
	 */
	public function loadModel($id, $modelClass=__CLASS__)
	{
		$model = Estaciones::model()->findByPk($id);
		if($model === null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model, $form=null)
	{
		if(isset($_POST['ajax']) && $_POST['ajax'] === 'estaciones-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
        
        /**
         * Upload handler
         */
        public function actionUpload(){
        	Yii::import( "xupload.models.XUploadForm" );
        	//Here we define the paths where the files will be stored temporarily
        
        	$path = realpath(Yii::app()->getBasePath()."/../archivos/uploads/tmp/" )."/";
        	$publicPath = Yii::app()->getBaseUrl()."/archivos/uploads/tmp/";
        
        
        	//This is for IE which doens't handle 'Content-type: application/json' correctly
        	header( 'Vary: Accept' );
        	if( isset( $_SERVER['HTTP_ACCEPT'] )
        	&& (strpos( $_SERVER['HTTP_ACCEPT'], 'application/json' ) !== false) ) {
        		header( 'Content-type: application/json' );
        	} else {
        		header( 'Content-type: text/plain' );
        	}
        
        	//Here we check if we are deleting and uploaded file
        	if( isset( $_GET["_method"] ) ) {
        		if( $_GET["_method"] == "delete" ) {
        			if( $_GET["file"][0] !== '.' ) {
        				$file = $path.$_GET["file"];
        				if( is_file( $file ) ) {
        					unlink( $file );
        				}
        			}
        			echo json_encode( true );
        		}
        	} else {
        		$model = new XUploadForm;
        		$model->file = CUploadedFile::getInstance( $model, 'file' );
        		//We check that the file was successfully uploaded
        		if( $model->file !== null ) {
        			//Grab some data
        			$model->mime_type = $model->file->getType();
        			$model->size = $model->file->getSize();
        			$model->name = $model->file->getName();
        			$model->titulo = Yii::app()->request->getPost('titulo', '');
        			$model->descripcion = Yii::app()->request->getPost('descripcion', '');
        			//(optional) Generate a random name for our file
        			$filename = md5( Yii::app( )->user->id.microtime( ).$model->name);
        			$filename .= ".".$model->file->getExtensionName( );
        			if( $model->validate( ) ) {
        				//Move our file to our temporary dir
        				$model->file->saveAs( $path.$filename );
        				chmod( $path.$filename, 0777 );
        				//here you can also generate the image versions you need
        				//using something like PHPThumb
        
        
        				//Now we need to save this path to the user's session
        				if( Yii::app( )->user->hasState( 'images' ) ) {
        					$userImages = Yii::app( )->user->getState( 'images' );
        				} else {
        					$userImages = array();
        				}
        				$userImages[] = array(
        						"path" => $path.$filename,
        						//the same file or a thumb version that you generated
        						"thumb" => $path.$filename,
        						"filename" => $filename,
        						'size' => $model->size,
        						'mime' => $model->mime_type,
        						'name' => $model->name,
        						'titulo' => $model->titulo,
        						'descripcion' => $model->descripcion,
        				);
        				Yii::app( )->user->setState( 'images', $userImages );
        
        				//Now we need to tell our widget that the upload was succesfull
        				//We do so, using the json structure defined in
        				// https://github.com/blueimp/jQuery-File-Upload/wiki/Setup
        				echo json_encode( array( array(
        						"name" => $model->name,
        						'titulo' => $model->titulo,
        						'descripcion' => $model->descripcion,
        						"type" => $model->mime_type,
        						"size" => $model->size,
        						"url" => $publicPath.$filename,
        						"thumbnail_url" => $publicPath."$filename",
        						"delete_url" => $this->createUrl( "upload", array(
        								"_method" => "delete",
        								"file" => $filename
        						) ),
        						"delete_type" => "POST"
        				) ) );
        			} else {
        				//If the upload failed for some reason we log some data and let the widget know
        				echo json_encode( array(
        						array( "error" => $model->getErrors( 'file' ),
        						) ) );
        				Yii::log( "XUploadAction: ".CVarDumper::dumpAsString( $model->getErrors( ) ),
        				CLogger::LEVEL_ERROR, "xupload.actions.XUploadAction"
        						);
        			}
        		} else {
        			throw new CHttpException( 500, "Could not upload file" );
        		}
        	}
        }
        
        
        /**
	 * Exportar informacion a Excel
	 */
        public function actionExportar($export = true)
        {   
          
          if($export)
          {
            $model = Estaciones::model()->with('idEstacionMasters')->findAll();
             $this->widget('application.extensions.EExcelView', array(
                'dataProvider'=> new CActiveDataProvider('Estaciones'),
                
                'columns'=>array(
                //'idEstacion',
                 /*array(
                                'name'=>'idPlaza',
                                'value'=>($model->idPlaza0 !== null) ? $model->idPlaza0.' ' : null,
                                'type'=>'html',
                        ), */
                'idEstacionMasters.idPlaza0.Nombre',    
                'idEstacionMasters.Siglas',
                'idEstacionMasters.RazonSocial',
                
                'idEstacionMasters.Banda',
                /*array(
                                'name'=>'idEstado',
                                'value'=>($model->idEstado0 !== null) ? $model->idEstado0.' ' : null,
                                'type'=>'html',
                        ),*/
                'idEstacionMasters.idPlaza0.estado.Estado',
                //'Poblacion',
                'UbicacionEstudios',
                'CoordenadasEstudios',
                //'UbicacionAntena',
                //'CoordenadasAntena',
                ),
        ));   
              
            
            Yii::app()->end();
          } 

        }
        
        public function getTabularFormTabs($model)
        {
            $tabs = array();
            $count = 0;
            //foreach (array('en'=>'English', 'fi'=>'Finnish', 'sv'=>'Swedish') as $locale => $language)
            //{
                
                //if(count($model->idPlaza0)>0){
            
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Plaza a la que pertenece',
                        'content'=>Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/plaza/view.php', array('model'=>$model->idPlaza0), true),
                        
                    );
                
                //}
                
                    
                
                
                
                
                
                $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('representanteslegales/create', 'id'=>$model->idEstacion),
                    ),TRUE);
                    foreach($model->representantesLegales as $representantesLegales){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/representantesLegales/view.php', array('model'=>$representantesLegales), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Representantes legales',
                        'content'=>$temp,
                        
                    );
                
                
                
                
                    $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar Seguro de Equipo',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('seguros/create', 'id'=>$model->idEstacion, 'tipo'=>'Equipo'),
                    ),TRUE);
                    $temp .= " ";
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar Seguro de Responsabilidad Civil',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('seguros/create', 'id'=>$model->idEstacion, 'tipo'=>'Civil'),
                    ),TRUE);
                    $temp .= " ";
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar Seguro de Desastre',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('seguros/create', 'id'=>$model->idEstacion, 'tipo'=>'Desastre'),
                    ),TRUE);
                    foreach($model->seguroses as $seguro){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/seguros/view.php', array('model'=>$seguro), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Seguros',
                        'content'=>$temp,
                        
                    );
                    
                    
                    
                    
                    
                    
                    
                
                
                
                
            //}
            return $tabs;
        }
        
        public function getTabularFormTabs2($model)
        {
            $tabs = array();
            $count = 0;
            //foreach (array('en'=>'English', 'fi'=>'Finnish', 'sv'=>'Swedish') as $locale => $language)
            //{
                
                    
                    if($model->Banda=="AM"){
                    
                        //areatecnicaam
                        $temp = '';
                        $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                            'label'=>'Agregar',
                            'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                            'size'=>'mini', // null, 'large', 'small' or 'mini'
                            'icon'=>'icon-plus icon-white',
                            'url'=>array('areaTecnicaAM/create', 'id'=>$model->idEstacion),
                        ),TRUE);
                        foreach($model->areaTecnicaAMs as $areaTecnicaAM){
                            $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/areaTecnicaAM/view.php', array('model'=>$areaTecnicaAM), true);
                        }

                        $tabs[] = array(
                            'active'=>$count++ === 0,
                            'label'=>'Área técnica',
                            'content'=>$temp,

                        );
                
                        //transmisores am
                        $temp = '';
                        $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                            'label'=>'Agregar',
                            'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                            'size'=>'mini', // null, 'large', 'small' or 'mini'
                            'icon'=>'icon-plus icon-white',
                            'url'=>array('transmisoresAM/create', 'id'=>$model->idEstacion),
                        ),TRUE);
                        foreach($model->transmisoresAMs as $transmisorAM){
                            $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/transmisoresAM/view.php', array('model'=>$transmisorAM), true);
                        }

                        $tabs[] = array(
                            'active'=>$count++ === 0,
                            'label'=>'Transmisores',
                            'content'=>$temp,
                        );                
                        
                    }//banda am
            
                    if($model->Banda=="FM" || $model->Banda=="CB"){
                
                        //area tecnica FM
                        $temp = '';
                        $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                            'label'=>'Agregar',
                            'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                            'size'=>'mini', // null, 'large', 'small' or 'mini'
                            'icon'=>'icon-plus icon-white',
                            'url'=>array('areaTecnicaFM/create', 'id'=>$model->idEstacion),
                        ),TRUE);
                        foreach($model->areaTecnicaFMs as $areaTecnicaFM){
                            $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/areaTecnicaFM/view.php', array('model'=>$areaTecnicaFM), true);
                        }

                        $tabs[] = array(
                            'active'=>$count++ === 0,
                            'label'=>'Área técnica',
                            'content'=>$temp,

                        );
                        
                        //transmisores FM
                        $temp = '';
                        $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                            'label'=>'Agregar',
                            'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                            'size'=>'mini', // null, 'large', 'small' or 'mini'
                            'icon'=>'icon-plus icon-white',
                            'url'=>array('transmisoresFM/create', 'id'=>$model->idEstacion),
                        ),TRUE);
                        foreach($model->transmisoresFMs as $transmisorFM){
                            $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/transmisoresFM/view.php', array('model'=>$transmisorFM), true);
                        }

                        $tabs[] = array(
                            'active'=>$count++ === 0,
                            'label'=>'FM - Transmisores',
                            'content'=>$temp,

                        );
                
                    }//banda FM

                    //frecuenciaEnlace
                    $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('frecuenciaEnlace/create', 'id'=>$model->idEstacion),
                    ),TRUE);
                    
                    
                    foreach($model->frecuenciaEnlaces as $frecuenciaEnlace){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/frecuenciaEnlace/view.php', array('model'=>$frecuenciaEnlace), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Frecuencias de Enlace',
                        'content'=>$temp,
                        
                    );
                    
                    //Ifetel
                    $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                                    'label'=>'Agregar',
                                    'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                                    'size'=>'mini', // null, 'large', 'small' or 'mini'
                                    'icon'=>'icon-plus icon-white',
                                    'url'=>array('cofetel/create', 'id'=>$model->idEstacion),
                                  ), TRUE);
                    foreach($model->cofetels as $cofetel){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/cofetel/view.php', array('model'=>$cofetel), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'ifetel',
                        'content'=>$temp,
                        
                    );
                
                    if($model->Banda=="AM"){
                        
                        //documentacion tecnica am
                        $temp = '';
                        $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                            'label'=>'Agregar',
                            'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                            'size'=>'mini', // null, 'large', 'small' or 'mini'
                            'icon'=>'icon-plus icon-white',
                            'url'=>array('documentacionTecnicaAM/create', 'id'=>$model->idEstacion),
                        ),TRUE);
                        foreach($model->documentacionTecnicaAMs as $documentacionTecnicaAM){
                            $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/documentacionTecnicaAM/view.php', array('model'=>$documentacionTecnicaAM), true);
                        }

                        $tabs[] = array(
                            'active'=>$count++ === 0,
                            'label'=>'Documentación técnica',
                            'content'=>$temp,

                        );
                        
                        //acreditacion documentacion tecnica am
                        $temp = '';
                        $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                            'label'=>'Agregar',
                            'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                            'size'=>'mini', // null, 'large', 'small' or 'mini'
                            'icon'=>'icon-plus icon-white',
                            'url'=>array('acreditacionDocumentacionTecnicaAM/create', 'id'=>$model->idEstacion),
                        ),TRUE);
                        foreach($model->acreditacionDocumentacionTecnicaAMs as $acreditacionDocumentacionTecnicaAM){
                            $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/acreditacionDocumentacionTecnicaAM/view.php', array('model'=>$acreditacionDocumentacionTecnicaAM), true);
                        }

                        $tabs[] = array(
                            'active'=>$count++ === 0,
                            'label'=>'Acreditación de doc. técnica',
                            'content'=>$temp,

                        );

                    }//banda am
                    
                    if($model->Banda=="FM" || $model->Banda=="CB"){
                        //documentacion tecnica FM
                        $temp = '';
                        $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                            'label'=>'Agregar',
                            'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                            'size'=>'mini', // null, 'large', 'small' or 'mini'
                            'icon'=>'icon-plus icon-white',
                            'url'=>array('documentacionTecnicaFM/create', 'id'=>$model->idEstacion),
                        ),TRUE);
                        foreach($model->documentacionTecnicaFMs as $documentacionTecnicaFM){
                            $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/documentacionTecnicaFM/view.php', array('model'=>$documentacionTecnicaFM), true);
                        }

                        $tabs[] = array(
                            'active'=>$count++ === 0,
                            'label'=>'Documentación técnica',
                            'content'=>$temp,

                        );

                        //acreditacion documentacion tecnica FM
                        $temp = '';
                        $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                            'label'=>'Agregar',
                            'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                            'size'=>'mini', // null, 'large', 'small' or 'mini'
                            'icon'=>'icon-plus icon-white',
                            'url'=>array('acreditacionDocumentacionTecnicaFM/create', 'id'=>$model->idEstacion),
                        ),TRUE);
                        foreach($model->acreditacionDocumentacionTecnicaFMs as $acreditacionDocumentacionTecnicaFM){
                            $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/acreditacionDocumentacionTecnicaFM/view.php', array('model'=>$acreditacionDocumentacionTecnicaFM), true);
                        }

                        $tabs[] = array(
                            'active'=>$count++ === 0,
                            'label'=>'Acreditación de doc. técnica',
                            'content'=>$temp,

                        );
                        
                    }//banda FM
                    
                    //Observaciones
                        $temp = '';
                        $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                            'label'=>'Agregar',
                            'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                            'size'=>'mini', // null, 'large', 'small' or 'mini'
                            'icon'=>'icon-plus icon-white',
                            'url'=>array('observaciones/create', 'id'=>$model->idEstacion),
                        ),TRUE);
                        foreach($model->susobservaciones as $observaciones){
                            $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/observaciones/view.php', array('model'=>$observaciones), true);
                        }

                        $tabs[] = array(
                            'active'=>$count++ === 0,
                            'label'=>'Observaciones',
                            'content'=>$temp,

                        );
                        
                        
                        $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('controlInventario/create', 'id'=>$model->idEstacion),
                    ),TRUE);
                    foreach($model->controlInventarios as $controlinventario){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/controlInventario/view.php', array('model'=>$controlinventario), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Control de inventarios',
                        'content'=>$temp,
                        
                    );
                    
            //}
            return $tabs;
        }
        
        
        public function getTabularFormTabs3($model)
        {
            $tabs = array();
            $count = 0;
            //foreach (array('en'=>'English', 'fi'=>'Finnish', 'sv'=>'Swedish') as $locale => $language)
            //{
                
                
                    
                    $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('controlInventario/create', 'id'=>$model->idEstacion),
                    ),TRUE);
                    foreach($model->controlInventarios as $controlinventario){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/controlInventario/view.php', array('model'=>$controlinventario), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Control de inventarios',
                        'content'=>$temp,
                        
                    );
                    
                    $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('transmisores/create', 'id'=>$model->idEstacion),
                    ),TRUE);
                    foreach($model->transmisores as $transmisor){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/transmisores/view.php', array('model'=>$transmisor), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Inventario de transmisores ',
                        'content'=>$temp,
                        
                    );
                    
                    $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('equipoMedicion/create', 'id'=>$model->idEstacion),
                    ),TRUE);
                    foreach($model->equipoMedicions as $equipomedicion){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/equipoMedicion/view.php', array('model'=>$equipomedicion), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Equipo de medicion',
                        'content'=>$temp,
                        
                    );
                    
                    
                    $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('torresIluminacion/create', 'id'=>$model->idEstacion),
                    ),TRUE);
                    foreach($model->torresIluminacions as $torresiluminacion){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/torresIluminacion/view.php', array('model'=>$torresiluminacion), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Torres e iluminación',
                        'content'=>$temp,
                        
                    );
                    
                    
                    $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('equipoEnlace/create', 'id'=>$model->idEstacion),
                    ),TRUE);
                    foreach($model->equipoEnlaces as $equipoenlace){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/equipoEnlace/view.php', array('model'=>$equipoenlace), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Equipo de enlace',
                        'content'=>$temp,
                        
                    );
                    
                    
                    $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('peritaje/create', 'id'=>$model->idEstacion),
                    ),TRUE);
                    foreach($model->peritajes as $peritaje){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/peritaje/view.php', array('model'=>$peritaje), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Control de peritaje',
                        'content'=>$temp,
                        
                    );
                    
                    
                    $temp = '';
                    $temp .= $this->widget('bootstrap.widgets.TbButton', array(
                        'label'=>'Agregar',
                        'type'=>'success', // null, 'primary', 'info', 'success', 'warning', 'danger' or 'inverse'
                        'size'=>'mini', // null, 'large', 'small' or 'mini'
                        'icon'=>'icon-plus icon-white',
                        'url'=>array('fallasequipotecnico/create', 'id'=>$model->idEstacion),
                    ),TRUE);
                    foreach($model->fallasEquipoTecnicos as $fallasequipotecnico){
                        $temp .= Yii::app()->controller->renderFile(Yii::app()->basePath.'/views/fallasEquipoTecnico/view.php', array('model'=>$fallasequipotecnico), true);
                    }
                    
                    $tabs[] = array(
                        'active'=>$count++ === 0,
                        'label'=>'Fallas en Equipo tec.',
                        'content'=>$temp,
                        
                    );
                    
                    
                
                
                
                
            //}
            return $tabs;
        }
        
        public function formatoParteTecnicaAM($pt){
            switch ($pt) {
                case 'PU-AM':
                    return 'Plano de Ubicación';
                    break;
                case 'PT-AM':
                    return 'Plano del Terreno';
                    break;
                case 'DAM-AM':
                    return 'Diagrama de Acoplamiento Multiplex';
                    break;
                case 'CTE-AM':
                    return 'Caracteristicas Técnicas del Equipo';
                    break;
                case 'POM-AM':
                    return 'Proyecto de Operación Múltiple';
                    break;
                case 'PCE-AM-I':
                    return 'Prueba de Comportamiento del Equipo – VI';
                    break;
                case 'PCE-AM-II':
                    return 'Prueba de Comportamiento del Equipo – II';
                    break;
                default:
                    return 'aa';
                    break;
            }
        }
        
        public function formatoParteTecnicaFM($pt){
            switch ($pt) {
                case 'CTE-FM-I':
                    return 'Características Técnicas del Equipo – I';
                    break;
                case 'CTE-FM-II':
                    return 'Características Técnicas del Equipo – II';
                    break;
                case 'CTE-FM-III':
                    return 'Características Técnicas del Equipo – III';
                    break;
                case 'AS-FM':
                    return 'Área de Servicio';
                    break;
                case 'PU-FM':
                    return 'Plano de Ubicación';
                    break;
                case 'PCE-FM':
                    return 'Prueba de Comportamiento del Equipo';
                    break;
                case 'COM-FM':
                    return 'Croquis de Operación Múltiplex';
                    break;
                default:
                    return 'aa';
                    break;
            }
        }

        
}