<?php

class FrecuenciaEnlaceAniosController extends AweController
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
    public $layout = '//layouts/column2';

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		//$this->render('view', array(
		//	'model' => $this->loadModel($id),
		//));
                $model=$this->loadModel($id);
                $this->redirect(array('frecuenciaenlace/view', 'id' => $model->idFrecuenciaEnlace));
            
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate($id)
	{
		$model = new FrecuenciaEnlaceAnios;
                $frecuenciaEnlace = FrecuenciaEnlace::model()->findByPk($id);
                $this->performAjaxValidation($model, 'frecuencia-enlace-anios-form');

		if(isset($_POST['FrecuenciaEnlaceAnios']))
		{
			$model->attributes = $_POST['FrecuenciaEnlaceAnios'];
			if($model->save()){
                                if(!isset($_GET['ajax'])){
                                    Yii::app()->user->setFlash('anio-create', "Año agregado con éxito, <a href='".Yii::app()->createUrl('frecuenciaenlaceanios/create', array('id' => $id))."'> Haz clic aquí agregar uno más a esta estacion </a>");
                                    $this->redirect(array('frecuenciaenlace/view', 'id' => $model->idFrecuenciaEnlace));
                                }else{
                                    
                                    
                                    echo '<span class="badge badge-info">'.$model->Anio.'</span>';


                                }
                        }
		}
                if(!isset($_GET['ajax'])){
                    $this->render('create',array(
			'model' => $model,
                        'frecuenciaEnlace'=>$frecuenciaEnlace,
                    ));
                }
		
	}
        
        public function actionAgregar(){
            $model = new FrecuenciaEnlaceAnios;
            $model->idFrecuenciaEnlace = intval($_GET['idfrecuenciaenlace']);
            $model->Anio = date('Y');
            $model->save();
        }
        
	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model=$this->loadModel($id);
                $this->redirect(array('frecuenciaenlace/view', 'id' => $model->idFrecuenciaEnlace));
                /*$this->performAjaxValidation($model, 'frecuencia-enlace-anios-form');

		if(isset($_POST['FrecuenciaEnlaceAnios']))
		{
			$model->attributes = $_POST['FrecuenciaEnlaceAnios'];
			if($model->save())
				$this->redirect(array('view','id' => $model->id));
		}

		$this->render('update',array(
			'model' => $model,
		));
                 * 
                 */
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		if(Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			$this->loadModel($id)->delete();

			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
				$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
		}
		else
			throw new CHttpException(400, 'Invalid request. Please do not repeat this request again.');
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$dataProvider=new CActiveDataProvider('FrecuenciaEnlaceAnios');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
                
                $this->redirect(array('frecuenciaenlace/admin'));
		/*
                $model = new FrecuenciaEnlaceAnios('search');
		$model->unsetAttributes(); // clear any default values
		if(isset($_GET['FrecuenciaEnlaceAnios']))
			$model->attributes = $_GET['FrecuenciaEnlaceAnios'];

		$this->render('admin', array(
			'model' => $model,
		));
                 * 
                 */
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the ID of the model to be loaded
	 */
	public function loadModel($id, $modelClass=__CLASS__)
	{
		$model = FrecuenciaEnlaceAnios::model()->findByPk($id);
		if($model === null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model, $form=null)
	{
		if(isset($_POST['ajax']) && $_POST['ajax'] === 'frecuencia-enlace-anios-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
}
