<?php

class SiteController extends Controller
{
	/**
	 * Declares class-based actions.
	 */
	public function actions()
	{
		return array(
			// captcha action renders the CAPTCHA image displayed on the contact page
			'captcha'=>array(
				'class'=>'CCaptchaAction',
				'backColor'=>0xFFFFFF,
			),
			// page action renders "static" pages stored under 'protected/views/site/pages'
			// They can be accessed via: index.php?r=site/page&view=FileName
			'page'=>array(
				'class'=>'CViewAction',
			),
                        'upload'=>array(
                            'class'=>'xupload.actions.XUploadAction',
                            'path' =>Yii::app() -> getBasePath() . "/../uploads",
                            'publicPath' => Yii::app() -> getBaseUrl() . "/uploads",
                        ),
		);
        
	}
        
        public function filters()
        {
            return array(
                'accessControl', // perform access control for CRUD operations
            );
        }
        
        

        
        public function accessRules()
        {
                return array(
                        array('allow', // allow authenticated user to perform 'delete' and 'update' actions
                                //'actions'=>array('login','logout','error'),
                                'users'=>array('*'),
                        ),
                        array('allow', // allow authenticated user to perform 'delete' and 'update' actions
                                //'actions'=>array('index','login','logout','upload'),
                                'users'=>array('@'),
                        ),
                        array('deny',  // deny all users
                                'users'=>array('*'),
                        ),
                );
        }

	/**
	 * This is the default 'index' action that is invoked
	 * when an action is not explicitly requested by users.
	 */
	public function actionIndex()
	{
		// renders the view file 'protected/views/site/index.php'
		// using the default layout 'protected/views/layouts/main.php'
                
                
		$this->render('index');
	}

	/**
	 * This is the action to handle external exceptions.
	 */
	public function actionError()
	{
		if($error=Yii::app()->errorHandler->error)
		{
			if(Yii::app()->request->isAjaxRequest)
				echo $error['message'];
			else
				$this->render('error', $error);
		}
	}

	/**
	 * Displays the contact page
	 */
	public function actionContact()
	{
		$model=new ContactForm;
		if(isset($_POST['ContactForm']))
		{
			$model->attributes=$_POST['ContactForm'];
			if($model->validate())
			{
				$name='=?UTF-8?B?'.base64_encode($model->name).'?=';
				$subject='=?UTF-8?B?'.base64_encode($model->subject).'?=';
				$headers="From: $name <{$model->email}>\r\n".
					"Reply-To: {$model->email}\r\n".
					"MIME-Version: 1.0\r\n".
					"Content-type: text/plain; charset=UTF-8";

				mail(Yii::app()->params['adminEmail'],$subject,$model->body,$headers);
				Yii::app()->user->setFlash('contact','Thank you for contacting us. We will respond to you as soon as possible.');
				$this->refresh();
			}
		}
		$this->render('contact',array('model'=>$model));
	}

	/**
	 * Displays the login page
	 */
	public function actionLogin()
	{
            
                if($_GET){
                    if(isset($_GET["ujoo"])){


                        function decrypt($str, $key)
                        {   
                            $str = mcrypt_decrypt(MCRYPT_DES, $key, $str, MCRYPT_MODE_ECB);

                            $block = mcrypt_get_block_size('des', 'ecb');
                            $pad = ord($str[($len = strlen($str)) - 1]);
                            return substr($str, 0, strlen($str) - $pad);
                        }

                        $temp2 = rawurldecode($_GET["ujoo"]);
                        $userid = decrypt($temp2, "RADING09");

                        //print_r("El user ID logeado es: ".$userid);
                        

                            $model=new LoginForm;
                            
                            if($model->login()){
                               
                               if(Yii::app()->user->isGuest){
                                   //echo "guest";
                               }else{
                                   //echo "log";
                               }
                               $userid = intval($userid);
                               Yii::app()->user->setState('userid', $userid);
                               $usuario = Users::model()->findByPk($userid);
                               $grupos = Usergroups::model()->findAll();
                               $grupos_asignados = UserUsergroupMap::model()->findAll(array("condition"=>"user_id =  $userid"));
                               Yii::app()->user->setState('email', $usuario->email);
                               //echo Yii::app()->user->getState('prueba');
                               
                                
                                $this->redirect(array('site/index'));
                            }






                    }else{
                        if(Yii::app()->user->isGuest){
                            //redireccionamos a login
                            header('Location: http://localhost/intranet/index.php/component/users/?view=login');
                        }
                    }
                }else{
                    if(Yii::app()->user->isGuest){
                        //redireccionamos a login
                        header('Location: http://localhost/intranet/index.php/component/users/?view=login');
                    }
                }
            
                /*
		$model=new LoginForm;

		// if it is ajax validation request
		if(isset($_POST['ajax']) && $_POST['ajax']==='login-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}

		// collect user input data
		if(isset($_POST['LoginForm']))
		{
			$model->attributes=$_POST['LoginForm'];
			// validate user input and redirect to the previous page if valid
			if($model->validate() && $model->login())
				$this->redirect(Yii::app()->user->returnUrl);
		}
		// display the login form
		$this->render('login',array('model'=>$model));
                 * 
                 */
	}

	/**
	 * Logs out the current user and redirect to homepage.
	 */
	public function actionLogout()
	{
		Yii::app()->user->logout();
		$this->redirect(Yii::app()->homeUrl);
	}
}