<?php

/**
 * This is the model base class for the table "ing_AcreditacionDocumentacionTecnicaAM".
 * DO NOT MODIFY THIS FILE! It is automatically generated by AweCrud.
 * If any changes are necessary, you must set or override the required
 * property or method in class "AcreditacionDocumentacionTecnicaAM".
 *
 * Columns in table "ing_AcreditacionDocumentacionTecnicaAM" available as properties of the model,
 * followed by relations of table "ing_AcreditacionDocumentacionTecnicaAM" available as properties of the model.
 *
 * @property integer $id
 * @property integer $idEstacion
 * @property string $Acreditacion
 * @property string $OficioAutorizacion
 * @property string $FechaAutorizacion
 * @property string $EscritoPresentacion
 * @property string $FechaPresentacion
 * @property string $SctOficio
 * @property string $SctFecha
 *
 * @property Estaciones $idEstacion0
 */
abstract class BaseAcreditacionDocumentacionTecnicaAM extends AweActiveRecord {

    public static function model($className=__CLASS__) {
        return parent::model($className);
    }

    public function tableName() {
        return 'ing_AcreditacionDocumentacionTecnicaAM';
    }

    public static function representingColumn() {
        return 'Acreditacion';
    }

    public function rules() {
        return array(
            array('idEstacion', 'numerical', 'integerOnly'=>true),
            
            array('OficioAutorizacion, EscritoPresentacion, SctOficio', 'length', 'max'=>45),
            array('FechaAutorizacion, FechaPresentacion, SctFecha', 'safe'),
            array('idEstacion, Acreditacion, OficioAutorizacion, FechaAutorizacion, EscritoPresentacion, FechaPresentacion, SctOficio, SctFecha', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, idEstacion, Acreditacion, OficioAutorizacion, FechaAutorizacion, EscritoPresentacion, FechaPresentacion, SctOficio, SctFecha', 'safe', 'on'=>'search'),
        );
    }

    public function relations() {
        return array(
            'idEstacion0' => array(self::BELONGS_TO, 'Estaciones', 'idEstacion'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
                'id' => Yii::t('app', 'ID'),
                'idEstacion' => Yii::t('app', 'Estacion'),
                'Acreditacion' => Yii::t('app', 'Acreditacion'),
                'OficioAutorizacion' => Yii::t('app', 'Oficio Autorizacion'),
                'FechaAutorizacion' => Yii::t('app', 'Fecha Autorizacion'),
                'EscritoPresentacion' => Yii::t('app', 'Escrito Presentacion'),
                'FechaPresentacion' => Yii::t('app', 'Fecha Presentacion'),
                'SctOficio' => Yii::t('app', 'Ifetel Oficio'),
                'SctFecha' => Yii::t('app', 'Ifetel Fecha'),
                'idEstacion0' => null,
        );
    }

    public function search() {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('idEstacion', $this->idEstacion);
        $criteria->compare('Acreditacion', $this->Acreditacion, true);
        $criteria->compare('OficioAutorizacion', $this->OficioAutorizacion, true);
        $criteria->compare('FechaAutorizacion', $this->FechaAutorizacion, true);
        $criteria->compare('EscritoPresentacion', $this->EscritoPresentacion, true);
        $criteria->compare('FechaPresentacion', $this->FechaPresentacion, true);
        $criteria->compare('SctOficio', $this->SctOficio, true);
        $criteria->compare('SctFecha', $this->SctFecha, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public function behaviors() {
        return array_merge(array(
        ), parent::behaviors());
    }
    
    public function beforeDelete() {
    	$this->eliminarArchivos();
    
    	return parent::beforeDelete();
    }
    
    public function afterSave() {
    	$this->guardarArchivos();
    	
    	parent::afterSave();
    }
    
    /**
     * Elimina archivos tanto en carpeta final como en DB
     */
    public function eliminarArchivos(){
    	//Si se elimina el registro, se borran archivos adjuntos 
    	$archivos=Archivos::model()->findAll('idRelacionado=:idRelacionado AND tipo="acreeditaciondocumentaciontecnicaam"', array(':idRelacionado'=>$this->id));
    	foreach ($archivos as $archivo){
    		$archivo->delete();
    	}
    
    }
    
    
    /**
     * Guarda Archivos tanto en carpeta final como en DB y los relaciona al registro correspondiente
     */
    public function guardarArchivos() {
    	//If we have pending images
    	if( Yii::app()->user->hasState('images')){
    		$userImages = Yii::app()->user->getState('images');
    		//Resolve the final path for our images
    		$path = Yii::app()->getBasePath()."/../archivos/uploads/acreeditaciondocumentaciontecnicaam_{$this->id}/";
    		//Create the folder and give permissions if it doesnt exists
    		if(!is_dir($path)){
    			mkdir($path);
    			chmod($path,0777);
    		}
    
    		//Now lets create the corresponding models and move the files
    		foreach($userImages as $image) {
                        
    			if(is_file($image["path"])){
    				if(rename($image["path"], $path.$image["filename"])){
    					chmod( $path.$image["filename"], 0777 );
    					//TODO crear modelo para almacenar archivos
    
    
    					$img = new Archivos();
    					$img->size = $image["size"];
    					$img->mime = $image["mime"];
    					$img->name = $image["name"];
    					$img->titulo = ($image["titulo"]!="") ? $image["titulo"] : "N/A";
    					$img->descripcion = ($image["descripcion"]!="") ? $image["descripcion"] : "N/A";
    					$img->source = $image["filename"];
    					$img->idRelacionado = $this->id;
    					$img->tipo = "acreeditaciondocumentaciontecnicaam";
    					if(!$img->save()){
    						//Its always good to log something
    						Yii::log("Could not save Image:\n".CVarDumper::dumpAsString(
    						$img->getErrors()), CLogger::LEVEL_ERROR );
    						//this exception will rollback the transaction
    						throw new Exception('Could not save Image');
    					}
    				}
    			} else {
    				//You can also throw an execption here to rollback the transaction
    				Yii::log($image["path"]." is not a file", CLogger::LEVEL_WARNING );
    			}
    		}
    		//Clear the user's session
    		Yii::app()->user->setState('images', null);
    	}
    }
    
}