<?php

/**
 * This is the model base class for the table "jur_Archivos".
 * DO NOT MODIFY THIS FILE! It is automatically generated by AweCrud.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Archivos".
 *
 * Columns in table "jur_Archivos" available as properties of the model,
 * and there are no model relations.
 *
 * @property integer $id
 * @property string $titulo
 * @property string $descripcion
 * @property integer $idRelacionado
 * @property integer $tipo
 * @property string $name
 * @property string $source
 * @property string $size
 * @property string $mime
 * @property string $timestamp
 *
 */
abstract class BaseArchivos extends AweActiveRecord {

    public static function model($className=__CLASS__) {
        return parent::model($className);
    }

    public function tableName() {
        return 'ing_Archivos';
    }

    public static function representingColumn() {
        return 'descripcion';
    }

    public function rules() {
        return array(
            array('descripcion, idRelacionado, name, source, size, mime', 'required'),
            array('idRelacionado', 'numerical', 'integerOnly'=>true),
            array('titulo, name, source, size', 'length', 'max'=>255),
            array('mime', 'length', 'max'=>100),
        	array('tipo', 'length', 'max'=>100),
            array('id, titulo, descripcion, idRelacionado, tipo, name, source, size, mime, timestamp', 'safe', 'on'=>'search'),
        );
    }

    public function relations() {
        return array(
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
                'id' => Yii::t('app', 'ID'),
                'titulo' => Yii::t('app', 'Titulo'),
                'descripcion' => Yii::t('app', 'Descripcion'),
                'idRelacionado' => Yii::t('app', 'Id Relacionado'),
                'tipo' => Yii::t('app', 'Tipo'),
                'name' => Yii::t('app', 'Name'),
                'source' => Yii::t('app', 'Source'),
                'size' => Yii::t('app', 'Size'),
                'mime' => Yii::t('app', 'Mime'),
                'timestamp' => Yii::t('app', 'Timestamp'),
        );
    }

    public function search() {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('descripcion', $this->descripcion, true);
        $criteria->compare('idRelacionado', $this->idRelacionado);
        $criteria->compare('tipo', $this->tipo, true);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('source', $this->source, true);
        $criteria->compare('size', $this->size, true);
        $criteria->compare('mime', $this->mime, true);
        $criteria->compare('timestamp', $this->timestamp, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public function behaviors() {
        return array_merge(array(
            'CTimestampBehavior' => array(
                'class' => 'zii.behaviors.CTimestampBehavior',
                'createAttribute' => null,
                'updateAttribute' => 'timestamp',
                'timestampExpression' => new CDbExpression('NOW()'),
            )
        ), parent::behaviors());
    }
    
    public function beforeDelete() {
    	$folderName = $this->tipo."_";
        $dirname = Yii::app()->getBasePath()."/../".Yii::app()->params["imagenes"].$folderName.$this->idRelacionado;
        $filename = Yii::app()->getBasePath()."/../".Yii::app()->params["imagenes"].$folderName.$this->idRelacionado.'/'.$this->source;
        //echo $dirname;
        //echo $filename;

        if(unlink($filename)){
            //verificamos si el directorio esta vacio para borrarlo
            $vacio = true;
        	if (!is_readable($dirname)){ $vacio = false; };
        	$handle = opendir($dirname);
        	while (false !== ($entry = readdir($handle))) {
        		if ($entry != "." && $entry != "..") {
        			$vacio = false;
        		}
        	}
        	if($vacio){
        		//borramos
        		if(rmdir($dirname)){
        			//borrado
        		}else{
        			return false;
        		}
        	}
        }else{
            return false;
        }
        return parent::beforeDelete();
    }
    
}