<?php

/**
 * This is the model base class for the table "ing_AreaTecnicaAM".
 * DO NOT MODIFY THIS FILE! It is automatically generated by AweCrud.
 * If any changes are necessary, you must set or override the required
 * property or method in class "AreaTecnicaAM".
 *
 * Columns in table "ing_AreaTecnicaAM" available as properties of the model,
 * followed by relations of table "ing_AreaTecnicaAM" available as properties of the model.
 *
 * @property integer $id
 * @property integer $idEstacion
 * @property double $PotenciaDiurna
 * @property double $PotenciaNocturna
 * @property double $AlturaAntena
 * @property double $LongitudRadiales
 * @property double $NumeroRadiales
 * @property string $Impedancia
 * @property string $TipoAntena
 * @property string $Multiplex
 *
 * @property Estaciones $idEstacion0
 */
abstract class BaseAreaTecnicaAM extends AweActiveRecord {

    public static function model($className=__CLASS__) {
        return parent::model($className);
    }

    public function tableName() {
        return 'ing_AreaTecnicaAM';
    }

    public static function representingColumn() {
        return 'Impedancia';
    }

    public function rules() {
        return array(
            array('idEstacion, PotenciaDiurna, PotenciaNocturna, AlturaAntena, LongitudRadiales, NumeroRadiales, Impedancia', 'required'),
            array('idEstacion', 'numerical', 'integerOnly'=>true),
            array('PotenciaDiurna, PotenciaNocturna, AlturaAntena, LongitudRadiales, NumeroRadiales', 'numerical'),
            array('Impedancia, TipoAntena, Multiplex', 'length', 'max'=>255),
            array('idEstacion, PotenciaDiurna, PotenciaNocturna, AlturaAntena, LongitudRadiales, NumeroRadiales, Impedancia, TipoAntena, Multiplex', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, idEstacion, PotenciaDiurna, PotenciaNocturna, AlturaAntena, LongitudRadiales, NumeroRadiales, Impedancia, TipoAntena, Multiplex', 'safe', 'on'=>'search'),
        );
    }

    public function relations() {
        return array(
            'idEstacion0' => array(self::BELONGS_TO, 'Estaciones', 'idEstacion'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
                'id' => Yii::t('app', 'ID'),
                'idEstacion' => Yii::t('app', 'Estacion'),
                'PotenciaDiurna' => Yii::t('app', 'Potencia Diurna'),
                'PotenciaNocturna' => Yii::t('app', 'Potencia Nocturna'),
                'AlturaAntena' => Yii::t('app', 'Altura Antena'),
                'LongitudRadiales' => Yii::t('app', 'Longitud Radiales'),
                'NumeroRadiales' => Yii::t('app', 'Numero Radiales'),
                'Impedancia' => Yii::t('app', 'Impedancia'),
                'TipoAntena' => Yii::t('app', 'Tipo Antena'),
                'Multiplex' => Yii::t('app', 'Multiplex'),
                'AntenaMarca' => Yii::t('app', 'Marca Antena'),
                'AntenaModelo' => Yii::t('app', 'Antena Modelo'),
                'GananciaAntenaPotencia' => Yii::t('app', 'Ganancia Antena potencia'),
                'GananciaAntenaDB' => Yii::t('app', 'Ganancia Antena dB'),
                'LineaTransmisionMarca' => Yii::t('app', 'Linea Transmisi贸n Marca'),
                'LineaTransmisionModelo' => Yii::t('app', 'Linea Transmisi贸n Modelo'),
                'LineaTransmisionMetros' => Yii::t('app', 'Linea Transmisi贸n Metros'),
                'PerdidaLineaPorcentaje' => Yii::t('app', 'Perdida Linea Porcentaje'),
                'PerdidaLineaDb' => Yii::t('app', 'Perdida Linea dB'),
                'AsnmMetros' => Yii::t('app', 'A.S.N.M mt'),
                'idEstacion0' => null,
        );
    }

    public function search() {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('idEstacion', $this->idEstacion);
        $criteria->compare('PotenciaDiurna', $this->PotenciaDiurna);
        $criteria->compare('PotenciaNocturna', $this->PotenciaNocturna);
        $criteria->compare('AlturaAntena', $this->AlturaAntena);
        $criteria->compare('LongitudRadiales', $this->LongitudRadiales);
        $criteria->compare('NumeroRadiales', $this->NumeroRadiales);
        $criteria->compare('Impedancia', $this->Impedancia, true);
        $criteria->compare('TipoAntena', $this->TipoAntena, true);
        $criteria->compare('Multiplex', $this->Multiplex, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public function behaviors() {
        return array_merge(array(
        ), parent::behaviors());
    }
    
    public function beforeDelete() {
    	$this->eliminarArchivos();
    
    	return parent::beforeDelete();
    }
    
    public function afterSave() {
    	$this->guardarArchivos();
    	
    	parent::afterSave();
    }
    
    /**
     * Elimina archivos tanto en carpeta final como en DB
     */
    public function eliminarArchivos(){
    	//Si se elimina el registro, se borran archivos adjuntos 
    	$archivos=Archivos::model()->findAll('idRelacionado=:idRelacionado AND tipo="areatecnicaam"', array(':idRelacionado'=>$this->id));
    	foreach ($archivos as $archivo){
    		$archivo->delete();
    	}
    
    }
    
    
    /**
     * Guarda Archivos tanto en carpeta final como en DB y los relaciona al registro correspondiente
     */
    public function guardarArchivos() {
    	//If we have pending images
    	if( Yii::app()->user->hasState('images')){
    		$userImages = Yii::app()->user->getState('images');
    		//Resolve the final path for our images
    		$path = Yii::app()->getBasePath()."/../archivos/uploads/areatecnicaam_{$this->id}/";
    		//Create the folder and give permissions if it doesnt exists
    		if(!is_dir($path)){
    			mkdir($path);
    			chmod($path,0777);
    		}
    
    		//Now lets create the corresponding models and move the files
    		foreach($userImages as $image) {
                        
    			if(is_file($image["path"])){
    				if(rename($image["path"], $path.$image["filename"])){
    					chmod( $path.$image["filename"], 0777 );
    					//TODO crear modelo para almacenar archivos
    
    
    					$img = new Archivos();
    					$img->size = $image["size"];
    					$img->mime = $image["mime"];
    					$img->name = $image["name"];
    					$img->titulo = ($image["titulo"]!="") ? $image["titulo"] : "N/A";
    					$img->descripcion = ($image["descripcion"]!="") ? $image["descripcion"] : "N/A";
    					$img->source = $image["filename"];
    					$img->idRelacionado = $this->id;
    					$img->tipo = "areatecnicaam";
    					if(!$img->save()){
    						//Its always good to log something
    						Yii::log("Could not save Image:\n".CVarDumper::dumpAsString(
    						$img->getErrors()), CLogger::LEVEL_ERROR );
    						//this exception will rollback the transaction
    						throw new Exception('Could not save Image');
    					}
    				}
    			} else {
    				//You can also throw an execption here to rollback the transaction
    				Yii::log($image["path"]." is not a file", CLogger::LEVEL_WARNING );
    			}
    		}
    		//Clear the user's session
    		Yii::app()->user->setState('images', null);
    	}
    }
    
    
}