<?php

/**
 * This is the model base class for the table "ing_AreaTecnicaFM".
 * DO NOT MODIFY THIS FILE! It is automatically generated by AweCrud.
 * If any changes are necessary, you must set or override the required
 * property or method in class "AreaTecnicaFM".
 *
 * Columns in table "ing_AreaTecnicaFM" available as properties of the model,
 * followed by relations of table "ing_AreaTecnicaFM" available as properties of the model.
 *
 * @property integer $id
 * @property integer $idEstacion
 * @property double $PotenciaRadiadaAparente
 * @property double $PotenciaOperacion
 * @property double $PotenciaNominal
 * @property double $AlturaCentroElectrico
 * @property double $AlturaObstaculo
 * @property double $AlturaPromedio
 * @property string $Multiplex
 * @property string $ClaseEstacion
 * @property string $TecnicoResponsable
 * @property string $AntenaMarca
 * @property string $AntenaModelo
 * @property decimal $GananciaAntenaPotencia
 * @property decimal $GananciaAntenaDB
 * @property string $LineaTransmisionMarca
 * @property string $LineaTransmisionModelo
 * @property decimal $LineaTransmisionMetros
 * @property decimal $PerdidaLineaPorcentaje
 * @property decimal $PerdidaLineaDb
 * @property decimal $AsnmMetros
 *
 * @property Estaciones $idEstacion0
 */
abstract class BaseAreaTecnicaFM extends AweActiveRecord {

    public static function model($className=__CLASS__) {
        return parent::model($className);
    }

    public function tableName() {
        return 'ing_AreaTecnicaFM';
    }

    public static function representingColumn() {
        return 'Multiplex';
    }

    public function rules() {
        return array(
            array('idEstacion, AlturaCentroElectrico, AlturaObstaculo, AlturaPromedio', 'required'),
            array('idEstacion', 'numerical', 'integerOnly'=>true),
            array('PotenciaRadiadaAparente, PotenciaOperacion, PotenciaNominal, AlturaCentroElectrico, AlturaObstaculo, AlturaPromedio', 'numerical'),
            array('Multiplex', 'length', 'max'=>255),
            array('idEstacion, PotenciaRadiadaAparente, PotenciaOperacion, PotenciaNominal, AlturaCentroElectrico, AlturaObstaculo, AlturaPromedio, Multiplex, ClaseEstacion, TecnicoResponsable, AntenaMarca, AntenaModelo, GananciaAntenaPotencia, GananciaAntenaDB, LineaTransmisionMarca, LineaTransmisionModelo, LineaTransmisionMetros, PerdidaLineaPorcentaje, PerdidaLineaDb, AsnmMetros', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, idEstacion, PotenciaRadiadaAparente, PotenciaOperacion, PotenciaNominal, AlturaCentroElectrico, AlturaObstaculo, AlturaPromedio, Multiplex', 'safe', 'on'=>'search'),
        );
    }

    public function relations() {
        return array(
            'idEstacion0' => array(self::BELONGS_TO, 'Estaciones', 'idEstacion'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
                'id' => Yii::t('app', 'ID'),
                'idEstacion' => Yii::t('app', 'Estacion'),
                'PotenciaRadiadaAparente' => Yii::t('app', 'Potencia Radiada Aparente'),
                'PotenciaOperacion' => Yii::t('app', 'Potencia Operacion'),
                'PotenciaNominal' => Yii::t('app', 'Potencia Nominal'),
                'AlturaCentroElectrico' => Yii::t('app', 'Altura Centro Electrico'),
                'AlturaObstaculo' => Yii::t('app', 'Altura Obstaculo'),
                'AlturaPromedio' => Yii::t('app', 'Altura Promedio'),
                'Multiplex' => Yii::t('app', 'Multiplex'),
                'ClaseEstacion' => Yii::t('app', 'Clase de estación'),
                'TecnicoResponsable' => Yii::t('app', 'Tecnico responsable'),
                'AntenaMarca' => Yii::t('app', 'Marca Antena'),
                'AntenaModelo' => Yii::t('app', 'Antena Modelo'),
                'GananciaAntenaPotencia' => Yii::t('app', 'Ganancia Antena potencia'),
                'GananciaAntenaDB' => Yii::t('app', 'Ganancia Antena dB'),
                'LineaTransmisionMarca' => Yii::t('app', 'Linea Transmisi&oacute;n Marca'),
                'LineaTransmisionModelo' => Yii::t('app', 'Linea Transmisi&oacute;n Modelo'),
                'LineaTransmisionMetros' => Yii::t('app', 'Linea Transmisi&oacute;n Metros'),
                'PerdidaLineaPorcentaje' => Yii::t('app', 'Perdida Linea Porcentaje'),
                'PerdidaLineaDb' => Yii::t('app', 'Perdida Linea dB'),
                'AsnmMetros' => Yii::t('app', 'A.S.N.M mt'),
                'idEstacion0' => null,
        );
    }

    public function search() {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('idEstacion', $this->idEstacion);
        $criteria->compare('PotenciaRadiadaAparente', $this->PotenciaRadiadaAparente);
        $criteria->compare('PotenciaOperacion', $this->PotenciaOperacion);
        $criteria->compare('PotenciaNominal', $this->PotenciaNominal);
        $criteria->compare('AlturaCentroElectrico', $this->AlturaCentroElectrico);
        $criteria->compare('AlturaObstaculo', $this->AlturaObstaculo);
        $criteria->compare('AlturaPromedio', $this->AlturaPromedio);
        $criteria->compare('Multiplex', $this->Multiplex, true);
        $criteria->compare('AntenaMarca', $this->AntenaMarca);
        $criteria->compare('AntenaMarca', $this->AntenaModelo);
        $criteria->compare('AntenaMarca', $this->GananciaAntenaPotencia);
        $criteria->compare('AntenaMarca', $this->GananciaAntenaDB);
        $criteria->compare('AntenaMarca', $this->LineaTransmisionMarca);
        $criteria->compare('AntenaMarca', $this->LineaTransmisionModelo);
        $criteria->compare('AntenaMarca', $this->LineaTransmisionMetros);
        $criteria->compare('AntenaMarca', $this->PerdidaLineaPorcentaje);
        $criteria->compare('AntenaMarca', $this->PerdidaLineaDb);
        $criteria->compare('AntenaMarca', $this->AsnmMetros);        
        
        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public function behaviors() {
        return array_merge(array(
        ), parent::behaviors());
    }
    
    public function beforeDelete() {
    	$this->eliminarArchivos();
    	return parent::beforeDelete();
    }
    
    public function afterSave() {
    	$this->guardarArchivos();
    	parent::afterSave();
    }
    
    /**
     * Elimina archivos tanto en carpeta final como en DB
     */
    public function eliminarArchivos(){
    	//Si se elimina el registro, se borran archivos adjuntos 
    	$archivos=Archivos::model()->findAll('idRelacionado=:idRelacionado AND tipo="areatecnicafm"', array(':idRelacionado'=>$this->id));
    	foreach ($archivos as $archivo){
    		$archivo->delete();
    	}
    
    }
    
    
    /**
     * Guarda Archivos tanto en carpeta final como en DB y los relaciona al registro correspondiente
     */
    public function guardarArchivos() {
    	//If we have pending images
    	if( Yii::app()->user->hasState('images')){
    		$userImages = Yii::app()->user->getState('images');
    		//Resolve the final path for our images
    		$path = Yii::app()->getBasePath()."/../archivos/uploads/areatecnicafm_{$this->id}/";
    		//Create the folder and give permissions if it doesnt exists
    		if(!is_dir($path)){
    			mkdir($path);
    			chmod($path,0777);
    		}
    
    		//Now lets create the corresponding models and move the files
    		foreach($userImages as $image) {
                        
    			if(is_file($image["path"])){
    				if(rename($image["path"], $path.$image["filename"])){
    					chmod( $path.$image["filename"], 0777 );
    					//TODO crear modelo para almacenar archivos
    
    
    					$img = new Archivos();
    					$img->size = $image["size"];
    					$img->mime = $image["mime"];
    					$img->name = $image["name"];
    					$img->titulo = ($image["titulo"]!="") ? $image["titulo"] : "N/A";
    					$img->descripcion = ($image["descripcion"]!="") ? $image["descripcion"] : "N/A";
    					$img->source = $image["filename"];
    					$img->idRelacionado = $this->id;
    					$img->tipo = "areatecnicafm";
    					if(!$img->save()){
    						//Its always good to log something
    						Yii::log("Could not save Image:\n".CVarDumper::dumpAsString(
    						$img->getErrors()), CLogger::LEVEL_ERROR );
    						//this exception will rollback the transaction
    						throw new Exception('Could not save Image');
    					}
    				}
    			} else {
    				//You can also throw an execption here to rollback the transaction
    				Yii::log($image["path"]." is not a file", CLogger::LEVEL_WARNING );
    			}
    		}
    		//Clear the user's session
    		Yii::app()->user->setState('images', null);
    	}
    }
    
}