<?php

/**
 * This is the model base class for the table "ing_CalendarioDescanso".
 * DO NOT MODIFY THIS FILE! It is automatically generated by AweCrud.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CalendarioDescanso".
 *
 * Columns in table "ing_CalendarioDescanso" available as properties of the model,
 * and there are no model relations.
 *
 * @property integer $id
 * @property string $Fecha
 * @property string $Razon
 *
 */
abstract class BaseCalendarioDescanso extends AweActiveRecord {

    public static function model($className=__CLASS__) {
        return parent::model($className);
    }

    public function tableName() {
        return 'ing_CalendarioDescanso';
    }

    public static function representingColumn() {
        return 'Fecha';
    }

    public function rules() {
        return array(
            array('Fecha, Razon', 'required'),
            array('Razon', 'length', 'max'=>225),
            array('id, Fecha, Razon', 'safe', 'on'=>'search'),
        );
    }

    public function relations() {
        return array(
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
                'id' => Yii::t('app', 'ID'),
                'Fecha' => Yii::t('app', 'Fecha'),
                'Razon' => Yii::t('app', 'Razon'),
        );
    }

    public function search() {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('Fecha', $this->Fecha, true);
        $criteria->compare('Razon', $this->Razon, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public function behaviors() {
        return array_merge(array(
        ), parent::behaviors());
    }
    
    protected function afterSave(){
         //Buscamos todas las fechas a vencer de Cofetel == Plazo
        $plazos_cofetel = Cofetel::model()->findAll("Tipo=:Plazo", array(':Plazo'=>'Plazo'));
        
        foreach ($plazos_cofetel as $plazo_cofetel){
                        
                        if($plazo_cofetel->Plazo){
                            
                            $inhabiles = Yii::app()->db->createCommand()
                            ->select('*')
                            ->from('ing_CalendarioDescanso c')
                            ->where('(Fecha BETWEEN :Fecha AND DATE_ADD(:Fecha, INTERVAL :Plazo DAY)) AND DAYOFWEEK(Fecha) NOT IN (1,7)', array(':Fecha'=>$plazo_cofetel->Fecha, ':Plazo'=>$plazo_cofetel->Plazo))
                            ->queryAll(); 
                            //dias inhabiles entre esas fechas
                            
                            $fechasInhabiles = array();
                            
                            foreach ($inhabiles as $inhabil){
                                array_push($fechasInhabiles, date("Y-m-d",strtotime($inhabil["Fecha"])));
                            }
                            $plazo = $plazo_cofetel->Plazo;
                            $fechaVencimiento = $plazo_cofetel->Fecha;
                            //echo "vence actual: ".$plazo_cofetel->Vence. " ";
                            $habil = 0;
                            $dias = 1;
                            //while($dias<=$plazo){
                            while($habil!=$plazo){
                                //echo $dias." - ".$fechaVencimiento;
                                if(date("l", strtotime($fechaVencimiento))=="Saturday" || date("l", strtotime($fechaVencimiento))=="Sunday"){
                                    //
                                    $dias--;
                                    //echo " ". date("l", strtotime($fechaVencimiento));
                                    
                                }else{
                                    
                                    if(in_array($fechaVencimiento, $fechasInhabiles)){
                                        //
                                        $dias--;
                                        //echo " inhabil ";
                                    }else{
                                        $habil++;
                                        //echo " habil ";
                                    }
                                }
                                
                                    if($habil!=$plazo){
                                        //echo "Iteracion ".$dias." hoy es ".date("l", strtotime($fechaVencimiento))." fecha ".$fechaVencimiento."<br>";
                                        $fechaVencimiento = date('Y-m-d', strtotime($fechaVencimiento . ' + 1 day'));
                                        //$fechaVencimiento = date('Y-m-d', strtotime($fechaVencimiento . ' + 1 day'));
                                        $dias++;
                                    }
                                
                            }
                            
                            //actualizamos la fecha de vencimiento
                            
                            $plazo_cofetel->Vence = $fechaVencimiento;
                            //echo "vence final: ".$plazo_cofetel->Vence. " ";
                            $plazo_cofetel->save();
                            //SELECT WORKDAYS('2013-01-01', '2013-02-28') as habiles;
                            
                            
                        }
        }
        
    }
    
    protected function afterDelete(){
        //Buscamos todas las fechas a vencer de Cofetel == Plazo
        $plazos_cofetel = Cofetel::model()->findAll("Tipo=:Plazo", array(':Plazo'=>'Plazo'));
        
        foreach ($plazos_cofetel as $plazo_cofetel){
                        
                        if($plazo_cofetel->Plazo){
                            
                            $inhabiles = Yii::app()->db->createCommand()
                            ->select('*')
                            ->from('ing_CalendarioDescanso c')
                            ->where('(Fecha BETWEEN :Fecha AND DATE_ADD(:Fecha, INTERVAL :Plazo DAY)) AND DAYOFWEEK(Fecha) NOT IN (1,7)', array(':Fecha'=>$plazo_cofetel->Fecha, ':Plazo'=>$plazo_cofetel->Plazo))
                            ->queryAll(); 
                            //dias inhabiles entre esas fechas
                            
                            $fechasInhabiles = array();
                            
                            foreach ($inhabiles as $inhabil){
                                array_push($fechasInhabiles, date("Y-m-d",strtotime($inhabil["Fecha"])));
                            }
                            $plazo = $plazo_cofetel->Plazo;
                            $fechaVencimiento = $plazo_cofetel->Fecha;
                            //echo "vence actual: ".$plazo_cofetel->Vence. " ";
                            $habil = 0;
                            $dias = 1;
                            //while($dias<=$plazo){
                            while($habil!=$plazo){
                                //echo $dias." - ".$fechaVencimiento;
                                if(date("l", strtotime($fechaVencimiento))=="Saturday" || date("l", strtotime($fechaVencimiento))=="Sunday"){
                                    //
                                    $dias--;
                                    //echo " ". date("l", strtotime($fechaVencimiento));
                                    
                                }else{
                                    
                                    if(in_array($fechaVencimiento, $fechasInhabiles)){
                                        //
                                        $dias--;
                                        //echo " inhabil ";
                                    }else{
                                        $habil++;
                                        //echo " habil ";
                                    }
                                }
                                
                                    if($habil!=$plazo){
                                        //echo "Iteracion ".$dias." hoy es ".date("l", strtotime($fechaVencimiento))." fecha ".$fechaVencimiento."<br>";
                                        $fechaVencimiento = date('Y-m-d', strtotime($fechaVencimiento . ' + 1 day'));
                                        //$fechaVencimiento = date('Y-m-d', strtotime($fechaVencimiento . ' + 1 day'));
                                        $dias++;
                                    }
                                
                            }
                            
                            //actualizamos la fecha de vencimiento
                            
                            $plazo_cofetel->Vence = $fechaVencimiento;
                            //echo "vence final: ".$plazo_cofetel->Vence. " ";
                            $plazo_cofetel->save();
                            //SELECT WORKDAYS('2013-01-01', '2013-02-28') as habiles;
                            
                            
                        }
        }
        
    }
    
}