<?php

/**
 * This is the model base class for the table "ing_Cofetel".
 * DO NOT MODIFY THIS FILE! It is automatically generated by AweCrud.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Cofetel".
 *
 * Columns in table "ing_Cofetel" available as properties of the model,
 * followed by relations of table "ing_Cofetel" available as properties of the model.
 *
 * @property integer $id
 * @property integer $idEstacion
 * @property string $Tipo
 * @property string $Fecha
 * @property string $Solicita
 * @property string $Asunto
 * @property string $Observaciones
 * @property string $Plazo
 * @property string $Vence
 *
 * @property Estaciones $idEstacion0
 */
abstract class BaseCofetel extends AweActiveRecord {

    public static function model($className=__CLASS__) {
        return parent::model($className);
    }

    public function tableName() {
        return 'ing_Cofetel';
    }

    public static function representingColumn() {
        return 'Tipo';
    }

    public function rules() {
        return array(
            array('idEstacion', 'numerical', 'integerOnly'=>true),
            array('Tipo', 'length', 'max'=>50),
            array('Fecha, Solicita, Numero, HabilesNaturales, Asunto, Observaciones, Plazo, Vence', 'safe'),
            array('idEstacion, Tipo, Fecha, Solicita, Asunto, Observaciones, Plazo, Vence', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, idEstacion, Tipo, Fecha, Solicita, Asunto, Observaciones, Plazo, Vence, Status', 'safe', 'on'=>'search'),
        );
    }

    public function relations() {
        return array(
            'idEstacion0' => array(self::BELONGS_TO, 'Estaciones', 'idEstacion'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
                'id' => Yii::t('app', 'ID'),
                'idEstacion' => Yii::t('app', 'Estacion'),
                'Tipo' => Yii::t('app', 'Tipo'),
                'Numero' => Yii::t('app', 'Numero Oficio-Escrito-Plazo'),
                'Fecha' => Yii::t('app', 'Fecha'),
                'Solicita' => Yii::t('app', 'Solicita'),
                'Asunto' => Yii::t('app', 'Asunto'),
                'Observaciones' => Yii::t('app', 'Observaciones'),
                'Plazo' => Yii::t('app', 'Plazo'),
                'HabilesNaturales' => Yii::t('app', 'HabilesNaturales'),
                'Vence' => Yii::t('app', 'Vence'),
                'idEstacion0' => null,
        );
    }

    public function search() {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('idEstacion', $this->idEstacion);
        $criteria->compare('Tipo', $this->Tipo, true);
        $criteria->compare('Numero', $this->Numero, true);
        $criteria->compare('Fecha', $this->Fecha, true);
        $criteria->compare('Solicita', $this->Solicita, true);
        $criteria->compare('Asunto', $this->Asunto, true);
        $criteria->compare('Observaciones', $this->Observaciones, true);
        $criteria->compare('Plazo', $this->Plazo, true);
        $criteria->compare('HabilesNaturales', $this->Plazo, true);
        $criteria->compare('Vence', $this->Vence, true);
        $criteria->compare('Status', $this->Status, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public function behaviors() {
        return array_merge(array(
        ), parent::behaviors());
    }
    
    public function beforeDelete() {
        $this->eliminarArchivos();
        return parent::beforeDelete();
    }

    public function afterSave() {
        $this->guardarArchivos();
        parent::afterSave();
    }

    /**
     * Elimina archivos tanto en carpeta final como en DB
     */
    public function eliminarArchivos() {
        //Si se elimina el registro, se borran archivos adjuntos 
        $archivos = Archivos::model()->findAll('idRelacionado=:idRelacionado AND tipo="cofetel"', array(':idRelacionado' => $this->id));
        foreach ($archivos as $archivo) {
            $archivo->delete();
        }
    }

    /**
     * Guarda Archivos tanto en carpeta final como en DB y los relaciona al registro correspondiente
     */
    public function guardarArchivos() {
        //If we have pending images
        if (Yii::app()->user->hasState('images')) {
            $userImages = Yii::app()->user->getState('images');
            //Resolve the final path for our images
            $path = Yii::app()->getBasePath() . "/../archivos/uploads/cofetel_{$this->id}/";
            //Create the folder and give permissions if it doesnt exists
            if (!is_dir($path)) {
                mkdir($path);
                chmod($path, 0777);
            }

            //Now lets create the corresponding models and move the files
            foreach ($userImages as $image) {

                if (is_file($image["path"])) {
                    if (rename($image["path"], $path . $image["filename"])) {
                        chmod($path . $image["filename"], 0777);
                        $img = new Archivos();
                        $img->size = $image["size"];
                        $img->mime = $image["mime"];
                        $img->name = $image["name"];
                        $img->titulo = ($image["titulo"] != "") ? $image["titulo"] : "N/A";
                        $img->descripcion = ($image["descripcion"] != "") ? $image["descripcion"] : "N/A";
                        $img->source = $image["filename"];
                        $img->idRelacionado = $this->id;
                        $img->tipo = "cofetel";
                        if (!$img->save()) {
                            //Its always good to log something
                            Yii::log("Could not save Image:\n" . CVarDumper::dumpAsString(
                                            $img->getErrors()), CLogger::LEVEL_ERROR);
                            //this exception will rollback the transaction
                            throw new Exception('Could not save Image');
                        }
                    }
                } else {
                    //You can also throw an execption here to rollback the transaction
                    Yii::log($image["path"] . " is not a file", CLogger::LEVEL_WARNING);
                }
            }
            //Clear the user's session
            Yii::app()->user->setState('images', null);
        }
    }
    
}