<?php

/**
 * This is the model base class for the table "ing_Estaciones".
 * DO NOT MODIFY THIS FILE! It is automatically generated by AweCrud.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Estaciones".
 *
 * Columns in table "ing_Estaciones" available as properties of the model,
 * followed by relations of table "ing_Estaciones" available as properties of the model.
 *
 * @property integer $idEstacion
 * @property integer $idPlaza
 * @property string $Siglas
 * @property string $RazonSocial
 * @property string $Frecuencia
 * @property string $Banda
 * @property integer $idEstado
 * @property string $Poblacion
 * @property string $UbicacionEstudios
 * @property string $CoordenadasEstudios
 * @property AcreditacionDocumentacionTecnicaAM[] $acreditacionDocumentacionTecnicaAMs
 * @property AcreditacionDocumentacionTecnicaFM[] $acreditacionDocumentacionTecnicaFMs
 * @property AreaTecnicaAM[] $areaTecnicaAMs
 * @property AreaTecnicaFM[] $areaTecnicaFMs
 * @property Cofetel[] $cofetels
 * @property ControlInventario[] $controlInventarios
 * @property DocumentacionTecnicaAM[] $documentacionTecnicaAMs
 * @property DocumentacionTecnicaFM[] $documentacionTecnicaFMs
 * @property EquipoEnlace[] $equipoEnlaces
 * @property EquipoMedicion[] $equipoMedicions
 * @property Estados $idEstado0
 * @property Plazas $idPlaza0
 * @property FallasEquipoTecnico[] $fallasEquipoTecnicos
 * @property FrecuenciaEnlace[] $frecuenciaEnlaces
 * @property Peritaje[] $peritajes
 * @property RepresentantesLegales[] $representantesLegales
 * @property Seguros[] $seguroses
 * @property TorresIluminacion[] $torresIluminacions
 * @property Transmisores[] $transmisores
 * @property TransmisoresAM[] $transmisoresAMs
 * @property TransmisoresFM[] $transmisoresFMs
 */
abstract class BaseEstaciones extends AweActiveRecord {
    
    public $RazonSocialSearch;
    public $BandaSearch;
    public $SiglasSearch;
    


    public static function model($className=__CLASS__) {
        return parent::model($className);
    }

    public function tableName() {
        return 'ing_Estaciones';
    }

    public static function representingColumn() {
        return 'Siglas';
    }

    public function rules() {
        return array(
            array('Frecuencia,UbicacionPlanta, CoordenadasPlanta', 'required'),
            array('idPlaza, idEstado', 'numerical', 'integerOnly'=>true),
            array('Siglas, Frecuencia, Combo', 'length', 'max'=>45),
            array('RazonSocial, Poblacion, Empresa, CoordenadasEstudios, CoordenadasEstudiosAuxiliares, CoordenadasPlanta, Concesionaria', 'length', 'max'=>255),
            array('Banda', 'length', 'max'=>2),
            array('UbicacionEstudios, UbicacionEstudiosAuxiliares, UbicacionPlanta, CiudadPrincipalServir, PlantaTransmisoraEmergente', 'safe'),
            array('idPlaza, RazonSocial, Frecuencia, Banda, idEstado, Poblacion, UbicacionEstudios, CoordenadasEstudios', 'default', 'setOnEmpty' => true, 'value' => null),
            array('idEstacion, idPlaza, RazonSocialSearch, BandaSearch, SiglasSearch, Siglas, RazonSocial, Frecuencia, Banda, idEstado, Poblacion, UbicacionEstudios, CoordenadasEstudios, UbicacionPlanta, CoordenadasPlanta, UbicacionEstudiosAuxiliares, CoordenadasEstudiosAuxiliares', 'safe', 'on'=>'search'),
        );
    }

    public function relations() {
        return array(
            'acreditacionDocumentacionTecnicaAMs' => array(self::HAS_MANY, 'AcreditacionDocumentacionTecnicaAM', 'idEstacion'),
            'acreditacionDocumentacionTecnicaFMs' => array(self::HAS_MANY, 'AcreditacionDocumentacionTecnicaFM', 'idEstacion'),
            'areaTecnicaAMs' => array(self::HAS_MANY, 'AreaTecnicaAM', 'idEstacion'),
            'areaTecnicaFMs' => array(self::HAS_MANY, 'AreaTecnicaFM', 'idEstacion'),
            'archivos' => array(self::HAS_MANY, 'Archivos', 'idEstacion'),
            'cofetels' => array(self::HAS_MANY, 'Cofetel', 'idEstacion'),
            'controlInventarios' => array(self::HAS_MANY, 'ControlInventario', 'idEstacion'),
            'documentacionTecnicaAMs' => array(self::HAS_MANY, 'DocumentacionTecnicaAM', 'idEstacion'),
            'documentacionTecnicaFMs' => array(self::HAS_MANY, 'DocumentacionTecnicaFM', 'idEstacion'),
            'equipoEnlaces' => array(self::HAS_MANY, 'EquipoEnlace', 'idEstacion'),
            'equipoMedicions' => array(self::HAS_MANY, 'EquipoMedicion', 'idEstacion'),
            //'idEstacionMasters' => array(self::BELONGS_TO, 'EstacionesMaster', 'idEstacionMaster'),
            'idEstado0' => array(self::BELONGS_TO, 'Estados', 'idEstado'),
            'idPlaza0' => array(self::BELONGS_TO, 'Plazas', 'idPlaza'),
            'fallasEquipoTecnicos' => array(self::HAS_MANY, 'FallasEquipoTecnico', 'idEstacion'),
            'frecuenciaEnlaces' => array(self::HAS_MANY, 'FrecuenciaEnlace', 'idEstacion'),
            'peritajes' => array(self::HAS_MANY, 'Peritaje', 'idEstacion'),
            'representantesLegales' => array(self::HAS_MANY, 'RepresentantesLegales', 'idEstacion'),
            'seguroses' => array(self::HAS_MANY, 'Seguros', 'idEstacion'),
            'torresIluminacions' => array(self::HAS_MANY, 'TorresIluminacion', 'idEstacion'),
            'transmisores' => array(self::HAS_MANY, 'Transmisores', 'idEstacion'),
            'transmisoresAMs' => array(self::HAS_MANY, 'TransmisoresAM', 'idEstacion'),
            'transmisoresFMs' => array(self::HAS_MANY, 'TransmisoresFM', 'idEstacion'),            
            'susobservaciones' => array(self::HAS_MANY, 'Observaciones', 'idEstacion'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
                'idEstacion' => Yii::t('app', 'Id Estacion'),
                'idPlaza' => Yii::t('app', 'Plaza'),
                'Siglas' => Yii::t('app', 'Distintivo de llamada'),
                'Empresa' => Yii::t('app', 'Empresa'),
                'Combo' => Yii::t('app', 'Combo'),
                'RazonSocial' => Yii::t('app', 'Razon Social'),
                'CiudadPrincipalServir' => Yii::t('app', 'Ciudad principal a servir'),
                'PlantaTransmisoraEmergente' => Yii::t('app', 'Planta Transmisora Emergente'),
                'RazonSocialSearch' => 'Razon Social',
                'BandaSearch' => 'Banda',
                'SiglasSearch' => 'Siglas',
                'Frecuencia' => Yii::t('app', 'Frecuencia'),
                'Banda' => Yii::t('app', 'Banda'),
                'idEstado' => Yii::t('app', 'Estado'),
                'Poblacion' => Yii::t('app', 'Poblacion'),
                'UbicacionEstudios' => Yii::t('app', 'Ubicacion de Estudios'),
                'CoordenadasEstudios' => Yii::t('app', 'Coordenadas de Estudios'),
                'UbicacionEstudiosAuxiliares' => Yii::t('app', 'Ubicacion de Estudios Auxiliares'),
                'CoordenadasEstudiosAuxiliares' => Yii::t('app', 'Coordenadas de Estudios Auxiliares'),
                'UbicacionPlanta' => Yii::t('app', 'Ubicacion de Planta'),
                'CoordenadasPlanta' => Yii::t('app', 'Coordenadas de Planta'),
                'acreditacionDocumentacionTecnicaAMs' => null,
                'acreditacionDocumentacionTecnicaFMs' => null,
                'areaTecnicaAMs' => null,
                'areaTecnicaFMs' => null,
                'cofetels' => null,
                'controlInventarios' => null,
                'documentacionTecnicaAMs' => null,
                'documentacionTecnicaFMs' => null,
                'equipoEnlaces' => null,
                'equipoMedicions' => null,
                'idEstado0' => null,
                'idPlaza0' => null,
                'fallasEquipoTecnicos' => null,
                'frecuenciaEnlaces' => null,
                'peritajes' => null,
                'representantesLegales' => null,
                'seguroses' => null,
                'torresIluminacions' => null,
                'transmisores' => null,
                'transmisoresAMs' => null,
                'transmisoresFMs' => null,
        );
    }

    public function search() {
        $criteria = new CDbCriteria;
        //$criteria->with = array('idEstacionMasters');
        
        
        $criteria->compare('idEstacion', $this->idEstacion);
        $criteria->compare('idEstado', $this->idEstado);
        
        
        //$criteria->compare('idEstacionMasters.RazonSocial', $this->RazonSocialSearch, true);
        //$criteria->compare('idEstacionMasters.Banda', $this->BandaSearch, true);
        //$criteria->compare('idEstacionMasters.Siglas', $this->SiglasSearch, true);
        
        //$criteria->compare('idEstacionMaster', $this->idEstacionMaster);
        $criteria->compare('idPlaza', $this->idPlaza);
        $criteria->compare('Concesionaria', $this->Concesionaria, true);
        $criteria->compare('Siglas', $this->Siglas, true);
        $criteria->compare('Empresa', $this->Empresa, true);
        $criteria->compare('Combo', $this->Combo, true);
        
        $criteria->compare('RazonSocial', $this->RazonSocial, true);
        //$criteria->compare('Frecuencia', $this->Frecuencia, true);
        $criteria->compare('Frecuencia', $this->Frecuencia);
        $criteria->compare('Banda', $this->Banda, true);
        //$criteria->compare('idEstado', $this->idEstado);
        
        $criteria->compare('Poblacion', $this->Poblacion, true);
        $criteria->compare('UbicacionEstudios', $this->UbicacionEstudios, true);
        $criteria->compare('UbicacionPlanta', $this->UbicacionPlanta, true);
        $criteria->compare('UbicacionEstudiosAuxiliares', $this->UbicacionEstudiosAuxiliares, true);
        $criteria->compare('CoordenadasEstudiosAuxiliares', $this->CoordenadasEstudiosAuxiliares, true);
        $criteria->compare('CoordenadasEstudios', $this->CoordenadasEstudios, true);
        //$criteria->compare('UbicacionAntena', $this->UbicacionAntena, true);
        //$criteria->compare('CoordenadasAntena', $this->CoordenadasAntena, true);
        $criteria->compare('CoordenadasPlanta', $this->CoordenadasPlanta, true);
        $criteria->compare('CiudadPrincipalServir', $this->CiudadPrincipalServir, true);
        
        
        
        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }
    
    

    public function behaviors() {
        return array_merge(array(
        ), parent::behaviors());
    }
    
    public function beforeDelete() {
    	$this->eliminarArchivos();
    
    	return parent::beforeDelete();
    }
    
    public function afterSave() {
    	$this->guardarArchivos();
    	
    	parent::afterSave();
    }
    
    /**
     * Elimina archivos tanto en carpeta final como en DB
     */
    public function eliminarArchivos(){
    	//Si se elimina el registro de la base de datos, los archivos se borran desde Archivos.php
    	$archivos=Archivos::model()->findAll('idRelacionado=:idRelacionado AND tipo="estacion"', array(':idRelacionado'=>$this->idEstacion));
    	foreach ($archivos as $archivo){
    		$archivo->delete();
    	}
    
    }
    
    
    /**
     * Guarda Archivos tanto en carpeta final como en DB y los relaciona al registro correspondiente
     */
    public function guardarArchivos() {
    	//If we have pending images
    	if( Yii::app()->user->hasState('images')){
    		$userImages = Yii::app()->user->getState('images');
    		//Resolve the final path for our images
    		$path = Yii::app()->getBasePath()."/../archivos/uploads/estacion_{$this->idEstacion}/";
    		//Create the folder and give permissions if it doesnt exists
    		if(!is_dir($path)){
    			mkdir($path);
    			chmod($path,0777);
    		}
    
    		//Now lets create the corresponding models and move the files
    		foreach($userImages as $image) {
                        
    			if(is_file($image["path"])){
    				if(rename($image["path"], $path.$image["filename"])){
    					chmod( $path.$image["filename"], 0777 );
    					//TODO crear modelo para almacenar archivos
    
    
    					$img = new Archivos();
    					$img->size = $image["size"];
    					$img->mime = $image["mime"];
    					$img->name = $image["name"];
    					$img->titulo = ($image["titulo"]!="") ? $image["titulo"] : "N/A";
    					$img->descripcion = ($image["descripcion"]!="") ? $image["descripcion"] : "N/A";
    					$img->source = $image["filename"];
    					$img->idRelacionado = $this->idEstacion;
    					$img->tipo = "estacion";
    					if(!$img->save()){
    						//Its always good to log something
    						Yii::log("Could not save Image:\n".CVarDumper::dumpAsString(
    						$img->getErrors()), CLogger::LEVEL_ERROR );
    						//this exception will rollback the transaction
    						throw new Exception('Could not save Image');
    					}
    				}
    			} else {
    				//You can also throw an execption here to rollback the transaction
    				Yii::log($image["path"]." is not a file", CLogger::LEVEL_WARNING );
    			}
    		}
    		//Clear the user's session
    		Yii::app()->user->setState('images', null);
    	}
    }
    
}