<?php

/**
 * This is the model base class for the table "ing_FrecuenciaEnlace".
 * DO NOT MODIFY THIS FILE! It is automatically generated by AweCrud.
 * If any changes are necessary, you must set or override the required
 * property or method in class "FrecuenciaEnlace".
 *
 * Columns in table "ing_FrecuenciaEnlace" available as properties of the model,
 * followed by relations of table "ing_FrecuenciaEnlace" available as properties of the model.
 *
 * @property integer $idFrecuenciaEnlace
 * @property integer $idEstacion
 * @property string $Tipo
 * @property double $Frecuencia
 * @property string $OficioAutorizacion
 *
 * @property Estaciones $idEstacion0
 * @property FrecuenciaEnlaceAnios[] $frecuenciaEnlaceAnioses
 */
abstract class BaseFrecuenciaEnlace extends AweActiveRecord {

    


    public static function model($className=__CLASS__) {
        return parent::model($className);
    }

    public function tableName() {
        return 'ing_FrecuenciaEnlace';
    }

    public static function representingColumn() {
        return 'Tipo';
    }

    public function rules() {
        return array(
            array('idEstacion, Tipo, Frecuencia, OficioAutorizacion', 'required'),
            array('idEstacion', 'numerical', 'integerOnly'=>true),
            array('Frecuencia', 'numerical'),
            array('Tipo', 'length', 'max'=>2),
            array('OficioAutorizacion', 'safe'),
            array('idEstacion, Tipo, Frecuencia, OficioAutorizacion', 'default', 'setOnEmpty' => true, 'value' => null),
            array('idFrecuenciaEnlace, idEstacion, Tipo, Frecuencia, OficioAutorizacion', 'safe', 'on'=>'search'),
        );
    }

    public function relations() {
        return array(
            'idEstacion0' => array(self::BELONGS_TO, 'Estaciones', 'idEstacion'),
            'frecuenciaEnlaceAnioses' => array(self::HAS_MANY, 'FrecuenciaEnlaceAnios', 'idFrecuenciaEnlace'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
                'idFrecuenciaEnlace' => Yii::t('app', 'Id Frecuencia Enlace'),
                'idEstacion' => Yii::t('app', 'Estacion (Siglas) <a href="#" rel="tooltip" title="Ingrese las siglas de la estación por ejemplo: XECO"><i class="icon-pregunta"></i></a>'),
                'Tipo' => Yii::t('app', 'Tipo'),
                'Frecuencia' => Yii::t('app', 'Frecuencia'),
                'OficioAutorizacion' => Yii::t('app', 'Oficio Autorizacion'),
                'idEstacion0' => null,
                'frecuenciaEnlaceAnioses' => null,
        );
    }

    public function search() {
        $criteria = new CDbCriteria;

        $criteria->compare('idFrecuenciaEnlace', $this->idFrecuenciaEnlace);
        $criteria->compare('idEstacion', $this->idEstacion);
        $criteria->compare('Tipo', $this->Tipo, true);
        $criteria->compare('Frecuencia', $this->Frecuencia);
        $criteria->compare('OficioAutorizacion', $this->OficioAutorizacion, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public function behaviors() {
        return array_merge(array(
        ), parent::behaviors());
    }
    
    public function beforeDelete() {
        $this->eliminarArchivos();
        return parent::beforeDelete();
    }

    public function afterSave() {
        $this->guardarArchivos();
        parent::afterSave();
    }

    /**
     * Elimina archivos tanto en carpeta final como en DB
     */
    public function eliminarArchivos() {
        //Si se elimina el registro, se borran archivos adjuntos 
        $archivos = Archivos::model()->findAll('idRelacionado=:idRelacionado AND tipo="frecuenciaenlace"', array(':idRelacionado' => $this->idFrecuenciaEnlace));
        foreach ($archivos as $archivo) {
            $archivo->delete();
        }
    }

    /**
     * Guarda Archivos tanto en carpeta final como en DB y los relaciona al registro correspondiente
     */
    public function guardarArchivos() {
        //If we have pending images
        if (Yii::app()->user->hasState('images')) {
            $userImages = Yii::app()->user->getState('images');
            //Resolve the final path for our images
            $path = Yii::app()->getBasePath() . "/../archivos/uploads/frecuenciaenlace_{$this->idFrecuenciaEnlace}/";
            //Create the folder and give permissions if it doesnt exists
            if (!is_dir($path)) {
                mkdir($path);
                chmod($path, 0777);
            }

            //Now lets create the corresponding models and move the files
            foreach ($userImages as $image) {

                if (is_file($image["path"])) {
                    if (rename($image["path"], $path . $image["filename"])) {
                        chmod($path . $image["filename"], 0777);
                        //TODO crear modelo para almacenar archivos


                        $img = new Archivos();
                        $img->size = $image["size"];
                        $img->mime = $image["mime"];
                        $img->name = $image["name"];
                        $img->titulo = ($image["titulo"] != "") ? $image["titulo"] : "N/A";
                        $img->descripcion = ($image["descripcion"] != "") ? $image["descripcion"] : "N/A";
                        $img->source = $image["filename"];
                        $img->idRelacionado = $this->idFrecuenciaEnlace;
                        $img->tipo = "frecuenciaenlace";
                        if (!$img->save()) {
                            //Its always good to log something
                            Yii::log("Could not save Image:\n" . CVarDumper::dumpAsString(
                                            $img->getErrors()), CLogger::LEVEL_ERROR);
                            //this exception will rollback the transaction
                            throw new Exception('Could not save Image');
                        }
                    }
                } else {
                    //You can also throw an execption here to rollback the transaction
                    Yii::log($image["path"] . " is not a file", CLogger::LEVEL_WARNING);
                }
            }
            //Clear the user's session
            Yii::app()->user->setState('images', null);
        }
    }
    
}