<?php

/**
 * This is the model base class for the table "ing_Seguros".
 * DO NOT MODIFY THIS FILE! It is automatically generated by AweCrud.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Seguros".
 *
 * Columns in table "ing_Seguros" available as properties of the model,
 * followed by relations of table "ing_Seguros" available as properties of the model.
 *
 * @property integer $id
 * @property integer $idEstacion
 * @property string $TipoSeguro
 * @property string $Aseguradora
 * @property string $NumeroPoliza
 * @property string $Fecha
 * @property string $MontoAsegurado
 * @property string $PeriodoAsegurado
 * @property string $FechaPago
 * @property string $FechaVencimiento
 * @property string $FechaReporte
 * @property string $TipoDesastre
 * @property string $FolioDesastre
 * @property string $FechaTramite
 * @property string $Observaciones
 *
 * @property Estaciones $idEstacion0
 */
abstract class BaseSeguros extends AweActiveRecord {

    public static function model($className=__CLASS__) {
        return parent::model($className);
    }

    public function tableName() {
        return 'ing_Seguros';
    }

    public static function representingColumn() {
        return 'TipoSeguro';
    }

    public function rules() {
        return array(
            array('idEstacion, TipoSeguro, Aseguradora, NumeroPoliza, Fecha, MontoAsegurado, PeriodoAsegurado, FechaPago, FechaVencimiento', 'required', 'on'=>'Equipo'),
            array('idEstacion, TipoSeguro, Aseguradora, NumeroPoliza, Fecha, MontoAsegurado, PeriodoAsegurado, FechaPago, FechaVencimiento', 'required', 'on'=>'Civil'),
            array('idEstacion, TipoSeguro, FechaPago, FechaReporte, TipoDesastre, FolioDesastre, FechaTramite, Observaciones', 'required', 'on'=>'Desastre'),
            array('idEstacion', 'numerical', 'integerOnly'=>true),
            array('TipoSeguro', 'length', 'max'=>8),
            array('Aseguradora, MontoAsegurado, TipoDesastre', 'length', 'max'=>255),
            array('NumeroPoliza, PeriodoAsegurado, FolioDesastre', 'length', 'max'=>45),
            array('Fecha, FechaPago, FechaReporte, FechaTramite, Observaciones', 'safe'),
            array('idEstacion, TipoSeguro, Aseguradora, NumeroPoliza, Fecha, MontoAsegurado, PeriodoAsegurado, FechaPago, FechaVencimiento, FechaReporte, TipoDesastre, FolioDesastre, FechaTramite, Observaciones', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, idEstacion, TipoSeguro, Aseguradora, NumeroPoliza, Fecha, MontoAsegurado, PeriodoAsegurado, FechaPago, FechaVencimiento, FechaReporte, TipoDesastre, FolioDesastre, FechaTramite, Observaciones', 'safe', 'on'=>'search'),
        );
    }

    public function relations() {
        return array(
            'idEstacion0' => array(self::BELONGS_TO, 'Estaciones', 'idEstacion'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
                'id' => Yii::t('app', 'ID'),
                'idEstacion' => Yii::t('app', 'Estacion'),
                'TipoSeguro' => Yii::t('app', 'Tipo Seguro'),
                'Aseguradora' => Yii::t('app', 'Aseguradora'),
                'NumeroPoliza' => Yii::t('app', 'Numero Poliza'),
                'Fecha' => Yii::t('app', 'Fecha'),
                'MontoAsegurado' => Yii::t('app', 'Monto Asegurado'),
                'PeriodoAsegurado' => Yii::t('app', 'Periodo Asegurado'),
                'FechaPago' => Yii::t('app', 'Fecha Pago'),
                'FechaVencimiento' => Yii::t('app', 'Fecha de Vencimiento'),
                'FechaReporte' => Yii::t('app', 'Fecha Reporte'),
                'TipoDesastre' => Yii::t('app', 'Tipo Desastre'),
                'FolioDesastre' => Yii::t('app', 'Folio Desastre'),
                'FechaTramite' => Yii::t('app', 'Fecha Tramite'),
                'Observaciones' => Yii::t('app', 'Observaciones'),
                'idEstacion0' => null,
        );
    }

    public function search() {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('idEstacion', $this->idEstacion);
        $criteria->compare('TipoSeguro', $this->TipoSeguro, true);
        $criteria->compare('Aseguradora', $this->Aseguradora, true);
        $criteria->compare('NumeroPoliza', $this->NumeroPoliza, true);
        $criteria->compare('Fecha', $this->Fecha, true);
        $criteria->compare('MontoAsegurado', $this->MontoAsegurado, true);
        $criteria->compare('PeriodoAsegurado', $this->PeriodoAsegurado, true);
        $criteria->compare('FechaPago', $this->FechaPago, true);
        $criteria->compare('FechaVencimiento', $this->FechaVencimiento, true);
        $criteria->compare('FechaReporte', $this->FechaReporte, true);
        $criteria->compare('TipoDesastre', $this->TipoDesastre, true);
        $criteria->compare('FolioDesastre', $this->FolioDesastre, true);
        $criteria->compare('FechaTramite', $this->FechaTramite, true);
        $criteria->compare('Observaciones', $this->Observaciones, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public function behaviors() {
        return array_merge(array(
        ), parent::behaviors());
    }
}