<?php

/**
 * This is the model base class for the table "ing_TransmisoresFM".
 * DO NOT MODIFY THIS FILE! It is automatically generated by AweCrud.
 * If any changes are necessary, you must set or override the required
 * property or method in class "TransmisoresFM".
 *
 * Columns in table "ing_TransmisoresFM" available as properties of the model,
 * followed by relations of table "ing_TransmisoresFM" available as properties of the model.
 *
 * @property integer $id
 * @property integer $idEstacion
 * @property string $Modalidad
 * @property string $Marca
 * @property string $Modelo
 * @property string $Serie
 * @property double $Potencia
 * @property double $Tension
 * @property double $Corriente
 * @property double $Eficiencia
 *
 * @property Estaciones $idEstacion0
 */
abstract class BaseTransmisoresFM extends AweActiveRecord {

    public $EstadoSearch;
    public $PlazaSearch;
    
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

    public function tableName() {
        return 'ing_TransmisoresFM';
    }

    public static function representingColumn() {
        return 'Modalidad';
    }

    public function rules() {
        return array(
            array('idEstacion, Modalidad, Marca, Modelo, Serie, Potencia, Tension, Corriente, Eficiencia', 'required'),
            array('Condicion, Observaciones, RegistroCofetel', 'safe'),
            array('idEstacion', 'numerical', 'integerOnly' => true),
            array('Potencia, Tension, Corriente, Eficiencia', 'numerical'),
            array('Modalidad, Marca, Modelo, Serie', 'length', 'max' => 255),
            array('idEstacion, Modalidad, Marca, Modelo, Serie, Potencia, Tension, Corriente, Eficiencia', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, idEstacion, Modalidad, Marca, Modelo, Serie, Potencia, Tension, Corriente, Eficiencia, Condicion, Observaciones, RegistroCofetel,EstadoSearch, PlazaSearch', 'safe', 'on' => 'search'),
        );
    }

    public function relations() {
        return array(
            'idEstacion0' => array(self::BELONGS_TO, 'Estaciones', 'idEstacion'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'id' => Yii::t('app', 'ID'),
            'idEstacion' => Yii::t('app', 'Estacion'),
            'Modalidad' => Yii::t('app', 'Modalidad'),
            'Marca' => Yii::t('app', 'Marca'),
            'Modelo' => Yii::t('app', 'Modelo'),
            'Serie' => Yii::t('app', 'Serie'),
            'Potencia' => Yii::t('app', 'Potencia'),
            'Tension' => Yii::t('app', 'Tension'),
            'Corriente' => Yii::t('app', 'Corriente'),
            'Eficiencia' => Yii::t('app', 'Eficiencia'),
            'Condicion' => Yii::t('app', 'Condicion'),
            'Observaciones' => Yii::t('app', 'Observaciones'),
            'RegistroCofetel' => Yii::t('app', 'Registro ante Cofetel'),
            'idEstacion0' => null,
            'EstadoSearch' => 'Estado',
            'PlazaSearch' => 'Plaza',
        );
    }

    public function search() {
        $criteria = new CDbCriteria;
        $criteria->with=array('idEstacion0','idEstacion0.idPlaza0');
        $criteria->together = true;
        $criteria->compare('id', $this->id);
        $criteria->compare('idEstacion', $this->idEstacion);
        $criteria->compare('Modalidad', $this->Modalidad, true);
        $criteria->compare('Marca', $this->Marca, true);
        $criteria->compare('Modelo', $this->Modelo, true);
        $criteria->compare('Serie', $this->Serie, true);
        $criteria->compare('Potencia', $this->Potencia);
        $criteria->compare('Tension', $this->Tension);
        $criteria->compare('Corriente', $this->Corriente);
        $criteria->compare('Eficiencia', $this->Eficiencia);
        $criteria->compare('Condicion', $this->Condicion, true);
        $criteria->compare('Observaciones', $this->Observaciones, true);
        $criteria->compare('RegistroCofetel', $this->RegistroCofetel, true);
        $criteria->compare('idEstacion0.idEstado', $this->EstadoSearch);
        $criteria->compare('idPlaza0.idPlaza', $this->PlazaSearch);
        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public function behaviors() {
        return array_merge(array(
                ), parent::behaviors());
    }
    
    public function beforeDelete() {
        $this->eliminarArchivos();
        return parent::beforeDelete();
    }

    public function afterSave() {
        $this->guardarArchivos();
        parent::afterSave();
    }

    /**
     * Elimina archivos tanto en carpeta final como en DB
     */
    public function eliminarArchivos() {
        //Si se elimina el registro, se borran archivos adjuntos 
        $archivos = Archivos::model()->findAll('idRelacionado=:idRelacionado AND tipo="transmisoresfm"', array(':idRelacionado' => $this->id));
        foreach ($archivos as $archivo) {
            $archivo->delete();
        }
    }

    /**
     * Guarda Archivos tanto en carpeta final como en DB y los relaciona al registro correspondiente
     */
    public function guardarArchivos() {
        //If we have pending images
        if (Yii::app()->user->hasState('images')) {
            $userImages = Yii::app()->user->getState('images');
            //Resolve the final path for our images
            $path = Yii::app()->getBasePath() . "/../archivos/uploads/transmisoresfm_{$this->id}/";
            //Create the folder and give permissions if it doesnt exists
            if (!is_dir($path)) {
                mkdir($path);
                chmod($path, 0777);
            }

            //Now lets create the corresponding models and move the files
            foreach ($userImages as $image) {

                if (is_file($image["path"])) {
                    if (rename($image["path"], $path . $image["filename"])) {
                        chmod($path . $image["filename"], 0777);
                        //TODO crear modelo para almacenar archivos


                        $img = new Archivos();
                        $img->size = $image["size"];
                        $img->mime = $image["mime"];
                        $img->name = $image["name"];
                        $img->titulo = ($image["titulo"] != "") ? $image["titulo"] : "N/A";
                        $img->descripcion = ($image["descripcion"] != "") ? $image["descripcion"] : "N/A";
                        $img->source = $image["filename"];
                        $img->idRelacionado = $this->id;
                        $img->tipo = "transmisoresfm";
                        if (!$img->save()) {
                            //Its always good to log something
                            Yii::log("Could not save Image:\n" . CVarDumper::dumpAsString(
                                            $img->getErrors()), CLogger::LEVEL_ERROR);
                            //this exception will rollback the transaction
                            throw new Exception('Could not save Image');
                        }
                    }
                } else {
                    //You can also throw an execption here to rollback the transaction
                    Yii::log($image["path"] . " is not a file", CLogger::LEVEL_WARNING);
                }
            }
            //Clear the user's session
            Yii::app()->user->setState('images', null);
        }
    }

}