<div class="form">
    <?php
    /** @var AcreditacionDocumentacionTecnicaAM $model */
    /** @var AweActiveForm $form */
    /** @var Estaciones $estacion */
    $form = $this->beginWidget('ext.AweCrud.components.AweActiveForm', array(
        'id' => 'acreditacion-documentacion-tecnica-am-form',
        'enableAjaxValidation' => true,
        'enableClientValidation' => false,
    ));
    Yii::app()->clientScript->registerCoreScript('jquery.ui', CClientScript::POS_HEAD);
    //Si JS es muy complejo mejor lo incluimos en script por separado
    Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/acreditacionam-form.js', CClientScript::POS_END);

    if (!$model->isNewRecord) {
        Yii::app()->clientScript->registerScript(
                'acreditaciondocumentaciontecnicaam-formulario-update',
                "$('#typeahead').val($('#AcreditacionDocumentacionTecnicaAM_idEstacion option:selected').text());"
                );
    } else {
        Yii::app()->clientScript->registerScript(
                'acreditaciondocumentaciontecnicaam-formulario-create', 
                "$('#typeahead').blur(function(){
                    $('#typeahead').val($('#typeahead').val().toUpperCase());
                    $('#AcreditacionDocumentacionTecnicaAM_idEstacion option').eq(estaciones[$('#typeahead').val().toUpperCase()]).attr('selected',true);
                });");
    }
    ?>

    <p class="note">
        <?php echo Yii::t('AweCrud.app', 'Fields with') ?> <span class="required">*</span>
        <?php echo Yii::t('AweCrud.app', 'are required') ?>.    </p>

    <?php echo $form->errorSummary($model) ?>


    <?php
    if ($model->isNewRecord) {
        echo $form->hiddenField($model, 'idEstacion', array('value' => $estacion->idEstacion));
    } else {
        echo $form->hiddenField($model, 'idEstacion');
    }
    ?>
    <?php //echo $form->textFieldRow($model, 'Acreditacion', array('class' => 'span5', 'maxlength' => 17)) ?>
    <label for="AcreditacionDocumentacionTecnicaAM_Acreditacion">Acreditación <a href="#" rel="tooltip" title="Seleccione el tipo de acreditación: Predio, Equipo Transmisor"><i class="icon-pregunta"></i></a></label>
    <?php echo $form->hiddenField($model, 'Acreditacion') ?>
    <?php
    $this->widget('bootstrap.widgets.TbButtonGroup', array(
        'type' => 'primary',
        'toggle' => 'radio', // 'checkbox' or 'radio'
        'buttons' => array(
            array('label' => 'Predio', 'htmlOptions' => array('class' => 'tipo-combo'), 'active' => $model->Acreditacion == "Predio" ? true : false),
            array('label' => 'Equipo Transmisor', 'htmlOptions' => array('class' => 'tipo-combo'), 'active' => $model->Acreditacion == "Equipo Transmisor" ? true : false),
        ),
    ));
    ?>
    
    
    <?php echo $form->textFieldRow($model, 'OficioAutorizacion', array('class' => 'span5', 'maxlength' => 45)) ?>
    <?php //echo $form->datepickerRow($model, 'FechaAutorizacion', array('prepend'=>'<i class="icon-calendar"></i>')) ?>
    <label for="AcreditacionDocumentacionTecnicaAM_FechaAutorizacion">Fecha de Autorización</label><i class="icon-calendar"></i>
    <?php
    $this->widget('zii.widgets.jui.CJuiDatePicker', array(
        'model' => $model,
        'attribute' => 'FechaAutorizacion',
        // additional javascript options for the date picker plugin
        'options' => array(
            'showAnim' => 'fold',
            'dateFormat' => 'yy-mm-dd',
        ),
        'htmlOptions' => array(
            'style' => 'height:20px;'
        ),
    ));
    ?>
    <?php echo $form->textFieldRow($model, 'EscritoPresentacion', array('class' => 'span5', 'maxlength' => 45)) ?>
    <?php //echo $form->datepickerRow($model, 'FechaPresentacion', array('prepend'=>'<i class="icon-calendar"></i>')) ?>
    <label for="AcreditacionDocumentacionTecnicaAM_FechaPresentacion">Fecha de Presentación</label><i class="icon-calendar"></i>
    <?php
    $this->widget('zii.widgets.jui.CJuiDatePicker', array(
        'model' => $model,
        'attribute' => 'FechaPresentacion',
        // additional javascript options for the date picker plugin
        'options' => array(
            'showAnim' => 'fold',
            'dateFormat' => 'yy-mm-dd',
        ),
        'htmlOptions' => array(
            'style' => 'height:20px;'
        ),
    ));
    ?>
    <?php echo $form->textFieldRow($model, 'SctOficio', array('class' => 'span5', 'maxlength' => 45)) ?>
    <?php //echo $form->datepickerRow($model, 'SctFecha', array('prepend'=>'<i class="icon-calendar"></i>')) ?>
    <label for="AcreditacionDocumentacionTecnicaAM_SctFecha">Fecha de registro en Ifetel</label><i class="icon-calendar"></i>
    <?php
    $this->widget('zii.widgets.jui.CJuiDatePicker', array(
        'model' => $model,
        'attribute' => 'SctFecha',
        // additional javascript options for the date picker plugin
        'options' => array(
            'showAnim' => 'fold',
            'dateFormat' => 'yy-mm-dd',
        ),
        'htmlOptions' => array(
            'style' => 'height:20px;'
        ),
    ));
    ?>
    <div class="form-actions">
        <?php
        $this->widget('bootstrap.widgets.TbButton', array(
            'buttonType' => 'submit',
            'type' => 'primary',
            'label' => $model->isNewRecord ? Yii::t('AweCrud.app', 'Create') : Yii::t('AweCrud.app', 'Save'),
        ));
        ?>
        <?php
        $this->widget('bootstrap.widgets.TbButton', array(
            //'buttonType'=>'submit',
            'label' => Yii::t('AweCrud.app', 'Cancel'),
            'htmlOptions' => array('onclick' => 'javascript:history.go(-1)')
        ));
        ?>
    </div>

    <?php $this->endWidget(); ?>

    <?php
    if (!$model->isNewRecord) {
        $losarchivos = new Archivos('search');
        $losarchivos->idRelacionado = $model->id;
        $losarchivos->tipo = "acreeditaciondocumentaciontecnicaam";
        $this->widget('bootstrap.widgets.TbGridView', array(
            'dataProvider' => $losarchivos->search(),
            //'filter'=>$losarchivos,
            'summaryText' => 'Archivos adjuntos',
            'emptyText' => '',
            'type' => 'striped',
            'enableSorting' => false,
            'enablePagination' => false,
            'showTableOnEmpty' => false,
            'columns' => array(
                array(
                    'name' => 'titulo',
                    'header' => 'Titulo',
                    'type' => 'raw',
                    'value' => 'CHtml::link($data->titulo, Yii::app()->getBaseUrl().Yii::app()->params["imagenes"]."acreeditaciondocumentaciontecnicaam_".$data->idRelacionado."/".$data->source, array("target"=>"_blank"))'
                ),
                array(
                    'name' => 'descripcion',
                    'header' => 'Descripción',
                    'type' => 'raw',
                    'value' => 'CHtml::link($data->descripcion, Yii::app()->getBaseUrl().Yii::app()->params["imagenes"]."acreeditaciondocumentaciontecnicaam_".$data->idRelacionado."/".$data->source, array("target"=>"_blank"))'
                ),
                array(
                    'class' => 'bootstrap.widgets.TbButtonColumn',
                    'template' => '{delete}',
                    'buttons' => array
                        (
                        'view' => array
                            (
                            'label' => 'Descargar',
                            'icon' => 'eye-open',
                            'url' => 'Yii::app()->getBaseUrl().Yii::app()->params["imagenes"]."acreeditaciondocumentaciontecnicaam_".$data->idRelacionado."/".$data->source',
                            'options' => array('target' => '_blank'),
                        ),
                        'delete' => array
                            (
                            'label' => 'Eliminar',
                            'icon' => 'trash',
                            'url' => 'Yii::app()->createUrl("archivos/delete", array("id"=>$data->id))',
                            'options' => array('class' => 'eliminar-archivo'),
                        ),
                    ), //buttons
                ), //array
            ), //columns
        )); //widget
    }
    ?>

</div>