<div class="form">
    <?php
    /** @var Cofetel $model */
    /** @var AweActiveForm $form */
    $form = $this->beginWidget('ext.AweCrud.components.AweActiveForm', array(
        'id' => 'cofetel-form',
        'enableAjaxValidation' => true,
        'enableClientValidation' => false,
    ));
    Yii::app()->clientScript->registerCoreScript('jquery.ui', CClientScript::POS_HEAD);
    //Si JS es muy complejo mejor lo incluimos en script por separado
    Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/cofetel-form.js', CClientScript::POS_END);
    
    //Si JS es simple mejor lo incluimos en script desde aquí
    if (!$model->isNewRecord) {
        Yii::app()->clientScript->registerScript(
                'cofetel-formulario-update', 
                "$('#typeahead').val($('#Cofetel_idEstacion option:selected').text());");
    } else {
        Yii::app()->clientScript->registerScript(
                'cofetel-formulario-create', 
                "$('#typeahead').blur(function(){
                    $('#typeahead').val($('#typeahead').val().toUpperCase());
                    $('#Cofetel_idEstacion option').eq(estaciones[$('#typeahead').val().toUpperCase()]).attr('selected',true);
                });");
    }
    ?>

    <p class="note">
<?php echo Yii::t('AweCrud.app', 'Fields with') ?> <span class="required">*</span>
        <?php echo Yii::t('AweCrud.app', 'are required') ?>.    </p>

        <?php echo $form->errorSummary($model) ?>

    <?php
    if ($model->isNewRecord) {
        echo $form->hiddenField($model, 'idEstacion', array('value' => $estacion->idEstacion));
    } else {
        echo $form->hiddenField($model, 'idEstacion');
    }
    ?>
    <?php //echo $form->textFieldRow($model, 'Tipo', array('class' => 'span5', 'maxlength' => 7)) ?>
    <label for="Cofetel_Tipo">Tipo <a href="#" rel="tooltip" title="Seleccione el tipo de documento: Escrito, Oficio, Plazo"><i class="icon-pregunta"></i></a></label>
    <?php echo $form->hiddenField($model, 'Tipo') ?>
    <?php
    $this->widget('bootstrap.widgets.TbButtonGroup', array(
        'type' => 'primary',
        'toggle' => 'radio', // 'checkbox' or 'radio'
        'buttons' => array(
            array('label' => 'Escrito', 'htmlOptions' => array('class' => 'tipo-combo'), 'active' => $model->Tipo == "Escrito" ? true : false),
            array('label' => 'Oficio', 'htmlOptions' => array('class' => 'tipo-combo'), 'active' => $model->Tipo == "Oficio" ? true : false),
            array('label' => 'Plazo', 'htmlOptions' => array('class' => 'tipo-combo'), 'active' => $model->Tipo == "Plazo" ? true : false),
            array('label' => 'Solicitud', 'htmlOptions' => array('class' => 'tipo-combo'), 'active' => $model->Tipo == "Solicitud" ? true : false),
            array('label' => 'Visita', 'htmlOptions' => array('class' => 'tipo-combo'), 'active' => $model->Tipo == "Visita" ? true : false),
        ),
    ));
    ?>
    <?php echo $form->textFieldRow($model, 'Numero', array('rows' => 6, 'cols' => 50, 'class' => 'span6')) ?>
    
    <?php //echo $form->datepickerRow($model, 'Fecha', array('prepend'=>'<i class="icon-calendar"></i>')) ?>
    <label for="Cofetel_Fecha">Fecha</label><i class="icon-calendar"></i>
    <?php
    $this->widget('zii.widgets.jui.CJuiDatePicker', array(
        'model' => $model,
        //'name'=>'Fecha',
        'attribute' => 'Fecha',
        // additional javascript options for the date picker plugin
        'options' => array(
            'showAnim' => 'fold',
            'dateFormat' => 'yy-mm-dd',
        ),
        'htmlOptions' => array(
            'style' => 'height:20px;'
        ),
    ));
    ?>
    <?php echo $form->textAreaRow($model, 'Solicita', array('rows' => 6, 'cols' => 50, 'class' => 'span6')) ?>
    <?php echo $form->textAreaRow($model, 'Asunto', array('rows' => 6, 'cols' => 50, 'class' => 'span6')) ?>
    <?php echo $form->textAreaRow($model, 'Observaciones', array('rows' => 6, 'cols' => 50, 'class' => 'span6')) ?>
    <?php echo $form->textFieldRow($model, 'Plazo', array('rows' => 6, 'cols' => 50, 'class' => 'span6')) ?>
    <label for="Cofetel_HabilesNaturales">Días habiles o naturales <a href="#" rel="tooltip" title="Para el Plazo seleccione si se tomarán días hábiles o naturales"><i class="icon-pregunta"></i></a></label>
    <?php echo $form->hiddenField($model, 'HabilesNaturales') ?>
    <?php
    $this->widget('bootstrap.widgets.TbButtonGroup', array(
        'type' => 'primary',
        'toggle' => 'radio', // 'checkbox' or 'radio'
        'buttons' => array(
            array('label' => 'Habiles', 'htmlOptions' => array('class' => 'habilesnaturales-combo'), 'active' => $model->HabilesNaturales == "1" ? true : false),
            array('label' => 'Naturales', 'htmlOptions' => array('class' => 'habilesnaturales-combo'), 'active' => $model->HabilesNaturales == "0" ? true : false),            
        ),
    ));
    ?>
    <?php //echo $form->textFieldRow($model, 'Vence', array('rows' => 6, 'cols' => 50, 'class' => 'span6')) ?>
    
    
    <div class="form-actions">
        <?php
        $this->widget('bootstrap.widgets.TbButton', array(
            'buttonType' => 'submit',
            'type' => 'primary',
            'label' => $model->isNewRecord ? Yii::t('AweCrud.app', 'Create') : Yii::t('AweCrud.app', 'Save'),
        ));
        ?>
        <?php
        $this->widget('bootstrap.widgets.TbButton', array(
            //'buttonType'=>'submit',
            'label' => Yii::t('AweCrud.app', 'Cancel'),
            'htmlOptions' => array('onclick' => 'javascript:history.go(-1)')
        ));
        ?>
    </div>

<?php $this->endWidget(); ?>
<?php
    if (!$model->isNewRecord) {
        $losarchivos = new Archivos('search');
        $losarchivos->idRelacionado = $model->id;
        $losarchivos->tipo = "cofetel";
        $this->widget('bootstrap.widgets.TbGridView', array(
            'dataProvider' => $losarchivos->search(),
            //'filter'=>$losarchivos,
            'summaryText' => 'Archivos adjuntos',
            'emptyText' => '',
            'type' => 'striped',
            'enableSorting' => false,
            'enablePagination' => false,
            'showTableOnEmpty' => false,
            'columns' => array(
                array(
                    'name' => 'titulo',
                    'header' => 'Titulo',
                    'type' => 'raw',
                    'value' => 'CHtml::link($data->titulo, Yii::app()->getBaseUrl().Yii::app()->params["imagenes"]."cofetel_".$data->idRelacionado."/".$data->source, array("target"=>"_blank"))'
                ),
                array(
                    'name' => 'descripcion',
                    'header' => 'Descripción',
                    'type' => 'raw',
                    'value' => 'CHtml::link($data->descripcion, Yii::app()->getBaseUrl().Yii::app()->params["imagenes"]."cofetel_".$data->idRelacionado."/".$data->source, array("target"=>"_blank"))'
                ),
                array(
                    'class' => 'bootstrap.widgets.TbButtonColumn',
                    'template' => '{delete}',
                    'buttons' => array
                        (
                        'view' => array
                            (
                            'label' => 'Descargar',
                            'icon' => 'eye-open',
                            'url' => 'Yii::app()->getBaseUrl().Yii::app()->params["imagenes"]."cofetel_".$data->idRelacionado."/".$data->source',
                            'options' => array('target' => '_blank'),
                        ),
                        'delete' => array
                            (
                            'label' => 'Eliminar',
                            'icon' => 'trash',
                            'url' => 'Yii::app()->createUrl("archivos/delete", array("id"=>$data->id))',
                            'options' => array('class' => 'eliminar-archivo'),
                        ),
                    ), //buttons
                ), //array
            ), //columns
        )); //widget
    }
?>
</div>